#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
using namespace std;

const int maxlen = 200500;
char str[maxlen];
const int maxn = maxlen * 2;


int go[maxn][30];
int suffLink[maxn];
int len[maxn];
int cnt[maxn][2];
int numV;


int addChar(int v, int pos)
{
	while (str[pos] != str[pos - len[v] - 1] )
	{
//		fprintf(stderr, "v = %d, len[v] = %d, sl = %d\n", v, len[v], suffLink[v] );
		v = suffLink[v];
	}
	if (go[v][str[pos] ] )
	{
		return go[v][str[pos] ];
	}
	int nv = go[v][str[pos] ] = numV++;
	len[nv] = len[v] + 2;
	int _v = suffLink[v];
	
	while (str[pos] != str[pos - len[_v] - 1] )
		_v = suffLink[_v];
	if (v == 0)
		_v = 1;
	else
		_v = go[_v][str[pos] ];
	
	suffLink[nv] = _v;
	return nv;
}


void addStr(int id)
{
	scanf("%s", str + 1);
	str[0] = -1;
	int len = strlen(str + 1);
	for (int i = 1; i <= len; i++)
		str[i] -= 'a';
	int v = 0;
	for (int i = 1; i <= len; i++)
	{
		v = addChar(v, i);
		cnt[v][id]++;
	}
}

void initTree()
{
	numV = 2;
	suffLink[1] = 0;
	len[0] = -1;
}

void clearTree()
{
	for (int i = 0; i < numV; i++)
	{
		memset(go[i], 0, sizeof go[i] );
		cnt[i][0] = cnt[i][1] = 0;
	}
	numV = 2;
}


void solve()
{
	addStr(0);
	addStr(1);
//	long long ans = 0;
	int ans1 = 0, ansE = 0, ans2 = 0;
	for (int i = numV - 1; i > 1; i--)
	{
		cnt[suffLink[i] ][0] += cnt[i][0];
		cnt[suffLink[i] ][1] += cnt[i][1];
		if (cnt[i][0] > cnt[i][1] )
			ans1++;
		else if (cnt[i][0] < cnt[i][1] )
			ans2++;
		else
			ansE++;
	}
	clearTree();
	printf("%d %d %d", ans1, ansE, ans2);
}



int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	initTree();
	int t;
	scanf("%d", &t);
	for (int i = 1; i <= t; i++)
	{
		printf("Case #%d: ", i);
		solve();
		printf("\n");
	}

	return 0;
}

