#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

struct node {
	int link;
	int len;
	int cnt;
	int to[27];
	node() {
		memset(to,-1,sizeof(to));
	}
};

vector<int> solve(string s) {
	forn(i, sz(s)) s[i] -= 'a';
	node root0, root1;
	root0.len = 0;
	root0.link = 1;
	root1.len = -1;
	root1.link = 1;
	root0.cnt = root1.cnt = 0;
	vector<node> t;
	t.pb(root0);
	t.pb(root1);
	int lst = 0;
	int n = sz(s);
	vector<int> ans(n);
	forn(i, n) {
		int ch = s[i];
		while (i-t[lst].len-1 < 0 || s[i-t[lst].len-1] != s[i]) lst = t[lst].link;
		if (t[lst].to[ch] == -1) {
			
			int pr = t[lst].link;
			while (s[i-t[pr].len-1] != s[i]) pr = t[pr].link;
			node cur;
			cur.len = t[lst].len + 2;
			cur.link = t[pr].to[ch];
			if (cur.len == 1) cur.link = 0;
			cur.cnt = t[cur.link].cnt+1;
			t[lst].to[ch] = sz(t);
			t.pb(cur);
		}
		lst = t[lst].to[ch];
		ans[i] = t[lst].cnt;
	}
	return ans;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	string s; cin >> s;
	vector<int> v1 = solve(s);
	reverse(ALL(s));
	vector<int> v2 = solve(s);
	reverse(ALL(v2));
	ll ans = 0;
	forn(i, sz(s)-1) ans += v1[i] * (ll)v2[i+1];
	cout << ans << "\n";
	return 0;
}
