#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

int I=0;

struct node {
	int link;
	int len;
	int cnt[2];
	int to[27];
	node() {
		memset(to,-1,sizeof(to));
		memset(cnt,0,sizeof(cnt));
	}
};

vector<node> t;

void solve(string s) {
	forn(i, sz(s)) s[i] -= 'a';
	int lst = 0;
	int n = sz(s);
	forn(i, n) {
		int ch = s[i];
		while (i-t[lst].len-1 < 0 || s[i-t[lst].len-1] != s[i]) lst = t[lst].link;
		if (t[lst].to[ch] == -1) {
			int pr = t[lst].link;
			while (s[i-t[pr].len-1] != s[i]) pr = t[pr].link;
			node cur;
			cur.len = t[lst].len + 2;
			cur.link = t[pr].to[ch];
			if (cur.len == 1) cur.link = 0;
			t[lst].to[ch] = sz(t);
			t.pb(cur);
		}
		lst = t[lst].to[ch];
		t[lst].cnt[I]++;
	}
}

void solve() {
	t.clear();
	node root0, root1;
	root0.len = 0;
	root0.link = 1;
	root1.len = -1;
	root1.link = 1;
	
	t.pb(root0);
	t.pb(root1);
	string s1, s2;
	cin >> s1 >> s2;
	I = 0;
	solve(s1);
	I = 1;
	solve(s2);
	vector<pii> v;
	forn(i, sz(t)) v.pb(mp(t[i].len, i));
	sort(ALL(v));
	reverse(ALL(v));
	forn(ii, sz(v)) {
		int cur = v[ii].Y;
		forn(j, 2) t[t[cur].link].cnt[j] += t[cur].cnt[j];
	}
	int c1 = 0, c2 = 0, c3 = 0;
	forn(ii, sz(v)) {
		int cur = v[ii].Y;
		if (cur < 2) continue;
		c1 += t[cur].cnt[0] > t[cur].cnt[1];
		c2 += t[cur].cnt[0] == t[cur].cnt[1];
		c3 += t[cur].cnt[0] < t[cur].cnt[1];
	}
	printf("%d %d %d\n", c1, c2, c3);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int T; scanf("%d", &T); for (int t = 1; t <= T; ++t) {
		printf("Case #%d: ", t);
		solve();
	}
	return 0;
}
