#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)2e5+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

struct node{
	int len, link, num;
	bool flag;
	int next[26];
	node(int _len, int _link, int  _num){
		len = _len;
		link = _link;
		num = _num;
		memset(next, -1, sizeof(next));
		flag = false;
	}
	node(){}
} a[2][maxn];


int sz[2], last[2];
char s[maxn];

void add(int v, int pos){
	int cur = s[pos]-'a';
	while ( s[pos] != s[pos - 1 - a[v][last[v]].len] )
		last[v] = a[v][last[v]].link;
	if ( a[v][last[v]].next[cur] != -1 ){
		last[v] = a[v][last[v]].next[cur];
		a[v][last[v]].num++;		
		return;
	}

	int link = a[v][last[v]].link;
	while ( s[pos] != s[pos - 1 - a[v][link].len])
		link = a[v][link].link;
	
	if ( a[v][link].next[cur] == -1 ) link = 1;
	else link = a[v][link].next[cur];

	a[v][sz[v]] = node(a[v][last[v]].len + 2, link, 1);
	a[v][last[v]].next[cur] = sz[v];
	last[v] = sz[v]++;
}

void init(int v){
	a[v][0] = node(-1, 0, 0);
	a[v][1] = node(0, 0, 0);
	last[v] = 0;
	sz[v] = 2;
}

void dfs1(int v1, int v2, int &ans1, int &ans2, int &ans3){
	if ( v2 == -1 ) ans1++;
	else if ( a[0][v1].num > a[1][v2].num ) ans1++;
	else if ( a[0][v1].num == a[1][v2].num) ans2+=(a[1][v1].num > 0);
	else ans3++;

	if ( v2 != -1 ){
		a[1][v2].flag = true;
	}

	for(int i=0;i<26;i++){
		if ( a[0][v1].next[i] != -1 ){
			int to;
			if ( v2 == -1 ) to = -1;
			else  to = a[1][v2].next[i];
			dfs1(a[0][v1].next[i], to, ans1, ans2, ans3);
		}
   	}
}

void dfs2(int v, int &ans1, int &ans2, int &ans3){
	if ( !a[1][v].flag ) ans3++;
	for (int i=0;i<26;i++){
		if ( a[1][v].next[i] != -1 )
			dfs2(a[1][v].next[i], ans1, ans2, ans3);
	}
}


void Solve(){
	for (int j=0;j<2;j++){
		init(j);
		scanf("%s", s + 1);
		int q = strlen(s+1);
		for (int i=1;i<=q;i++){
			add(j, i);
		}		
		for (int i=sz[j]-1;i>=0;i--){
			if ( a[j][i].link > 1 ){
				a[j][a[j][i].link].num += a[j][i].num;
			}
		}
		// do something
	}	

	int ans1 = 0, ans2 = 0 , ans3 = 0;
	dfs1(0, 0, ans1, ans2, ans3);
	dfs1(1, 1, ans1, ans2, ans3);

	dfs2(0, ans1, ans2, ans3);
	dfs2(1, ans1, ans2, ans3);

	printf("%d %d %d\n", ans1, ans2, ans3);
}

int main () {
	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif
	                
	int t;
	scanf("%d\n", &t);

	for (int i=0;i<t;i++){
		printf("Case #%d: ", i + 1);
		Solve();
	}
	




	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
