#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)1e6;
const int inf = (1 << 30) - 1;
const int CH = 26;

struct node {
	int suf, cnt, len;
	node() {suf = cnt = len = 0;}
} t[maxn];

int n, vn, to[maxn][CH], d[2][maxn];
char s[maxn];

void prtab(int tab) {for (int i = 0; i < tab; i++) printf("\t");}
void show(int v, char ch, int tab) {
	prtab(tab);
	printf("[---> %c %d, ^link %d, cnt %d]\n", ch, v, t[v].suf, t[v].cnt);
	for (int i = 0; i < 26; ++i) {
		if (to[v][i] != -1) show(to[v][i], char('a' + i), tab + 1);
	}
}

int create(int v, int d) {
	t[v] = node();
	t[v].len = d;
	for (int i = 0; i < CH; i++)
		to[v][i] = -1;
	return v;
}

int v, id;
void addLetter(int i, int head, int even) {
	int ch = s[i] - 'a';
	while (s[i] != s[i - t[v].len - 1]) v = t[v].suf;
	if (to[v][ch] != -1) {
		v = to[v][ch];
		t[v].cnt++;
		return;
	}
	int u = t[v].suf;
	while (s[i] != s[i - t[u].len - 1]) u = t[u].suf;
	u = (v == head ? even : to[u][ch]);
	v = to[v][ch] = create(vn++, t[v].len + 2);
	t[v].suf = u;
	t[v].cnt = t[u].cnt + 1;
	
	d[id][i] = t[v].cnt;
}

void build() {
	int head = create(vn++, -1);
	int even = create(vn++, 0);
	t[head].suf = head;
	t[even].suf = head;
	v = head;
	for (int i = 1; i <= n; i++) {
		addLetter(i, head, even);
	}
}

int main()
{


	scanf("%s", s + 1);
	n = strlen(s + 1);
	build();
	reverse(s + 1, s + n + 1); id = 1;
	build();
	reverse(d[1] + 1, d[1] + n + 1);

	LL ans = 0;
	for (int i = 1; i < n; i++) 
		ans += d[0][i] * 1ll * d[1][i+1];
	cout << ans << endl;
	

	return 0;
}



