#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li
#define link ololo

string s;
int len[2][301000];
int go[2][26][301000];
int link[2][301000];
int cou[2][301000];
int N[2];

void init(int id, int v) {
	len[id][v] = -1;
	link[id][v] = -1;
	cou[id][v] = 0;
	for (int i = 0; i < 26; ++i) {
		go[id][i][v] = -1;
	}

}

int curv = 1;

void init(int id) {
	init(id, 0);
	init(id, 1);
	
	len[id][1] = 0;
	link[id][1] = 0;

	N[id] = 2;

	for (int i = 0; i < 26; ++i) {
		
		init(id, N[id]);
		len[id][N[id]] = len[id][0] + 2;
		go[id][i][0] = N[id];
		link[id][N[id]] = 1;
		cou[id][N[id]] = 1;

		++N[id];
	}
}

vector <int> a[2];

void add(int id, int pos) {

	while (pos - len[id][curv] - 1 < 0 || s[pos] != s[pos - len[id][curv] - 1]) {
		curv = link[id][curv];
	}

	int newv;

	if (go[id][s[pos] - 'a'][curv] == -1) {
		init(id, N[id]);
		go[id][s[pos] - 'a'][curv] = N[id];
		len[id][N[id]] = len[id][curv] + 2;
		cou[id][N[id]] = 1;
		newv = N[id];
		++N[id];
	}
	else {
		newv = go[id][s[pos] - 'a'][curv];
	}

	if (link[id][newv] == -1) {
		curv = link[id][curv];

		while (pos - len[id][curv] - 1 < 0 || s[pos] != s[pos - len[id][curv] - 1]) {
			curv = link[id][curv];
		}

		link[id][newv] = go[id][s[pos] - 'a'][curv];
	}

	curv = newv;
	a[id].push_back(curv);
}

void build(int id) {
	init(id);

	curv = 1;
	for (int i = 0; i < s.size(); ++i) {
		add(id, i);
	}

	for (int i = 0; i < N[id]; ++i) {
		if (link[id][i] != -1) {
			cou[id][i] += cou[id][link[id][i]];
		}
	}
}

void solve() {

	string ss[2];
	cin >> ss[0];

	ss[1] = ss[0];
	reverse(ss[1].begin(), ss[1].end());

	for (int i = 0; i < 2; ++i) {
		a[i].reserve(ss[i].size());
		s = ss[i];
		build(i);
	}
	
	
	li ans = 0;

	for (int i = 0; i < ss[0].size() - 1; ++i) {
		ans += li(cou[0][a[0][i]]) * li(cou[1][a[1][ss[0].size() - i - 2]]);
	}
	cout << ans << endl;
}