#pragma comment(linker , "/STACK:128000000")

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int N;

li ans[100];

vector<int> cur;
vector<li> hashes[2];

set<li> used[100];

pair<li, li> getHash(int l, int r) {
	
	li fs = hashes[0][r] - hashes[0][l] * (1 << (r - l));

	li sc = (hashes[1][r] - hashes[1][l]) >> l;

	return mp(fs, sc);
}

void rec(int pos) {

	if (cur.size() == N + 1)
		return;

	int len = -1;
	li added = -1;

	for (int i = 0; i < pos; ++i) {
		pair<li, li> now = getHash(i, pos);
		if (now.first == now.second) {
			if (used[pos - i].count(now.first)) {
				return;
			}
			used[pos - i].insert(now.first);
			len = pos - i;
			added = now.first;
			break;
		}
	}

	++ans[cur.size()];

	for (int c = 0; c < 2; ++c) {
		hashes[0].push_back(hashes[0].back() * 2 + c);
		hashes[1].push_back(hashes[1].back() + c * (1LL << cur.size()));
		cur.push_back(c);

		rec(pos + 1);

		cur.pop_back();
		hashes[0].pop_back();
		hashes[1].pop_back();
	}

	if (len > 0)
		used[len].erase(added);

}

void solve() {
	cin >> N;
	for (int w = 0; w < 2; ++w)
		hashes[w].push_back(0);
	rec(0);
	for (int n = 1; n <= N; ++n) {
		cout << "ans[" << n << "] = " << ans[n] << ";\n";
	}

}