#pragma comment(linker , "/STACK:128000000")

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li
#define link ololo

int timerR = 0;

string s;
int len[601000];
int go[26][601000];
int link[601000];
int dp[2][601000];
int N;

void init(int v) {
	len[v] = -1;
	link[v] = -1;
	
	for (int i = 0; i < 26; ++i) {
		go[i][v] = -1;
	}

}

int curv = 1;

void init() {
	init(0);
	init(1);
	
	len[1] = 0;
	link[1] = 0;

	N = 2;

	for (int i = 0; i < 26; ++i) {
	
		init(N);
		len[N] = len[0] + 2;
		go[i][0] = N;

			
		link[N] = 1;
			

		++N;
	
	}
}

void add(int pos) {

	while (pos - len[curv] - 1 < 0 || s[pos] != s[pos - len[curv] - 1]) {
		curv = link[curv];
	}

	int newv;

	if (go[s[pos] - 'a'][curv] == -1) {
		init(N);
		go[s[pos] - 'a'][curv] = N;
		len[N] = len[curv] + 2;

		newv = N;
		++N;
	}
	else {
		newv = go[s[pos] - 'a'][curv];
	}

	if (link[newv] == -1) {
		curv = link[curv];

		while (pos - len[curv] - 1 < 0 || s[pos] != s[pos - len[curv] - 1]) {
			curv = link[curv];
		}

		link[newv] = go[s[pos] - 'a'][curv];
	}

	curv = newv;

}

int MAGIC = 5000;
const int INF = 2000000000;

void build() {

	curv = 1;
	
	dp[0][0] = 0;
	dp[1][0] = INF;
	int bestv[2] = {1, 1}; 
	for (int i = 0; i < s.size(); ++i) {
		
		dp[0][i + 1] = dp[1][i + 1] = INF;
		int bestvcopy[2] = {bestv[0], bestv[1]};

		int lastv = curv;
		add(i);
		//swap(lastv, curv);

		for (int k = 0; k < 2; ++k) {
			bestv[k] = -1;
		}

		for(int k = 0; k < 1; ++k) {
			//curv = bestvcopy[k];
			//add(i);
		


			int tmp = curv;
			for (int j = 0; j < MAGIC && tmp >= 2; ++j, tmp = link[tmp]) {
				int prev = i - len[tmp];
				for (int parity = 0; parity < 2; ++parity) {
					if(1 + dp[parity][prev + 1] < dp[!parity][i + 1]) {
						//cerr << "!!!" << i << " " << prev << "\n";
						dp[!parity][i + 1] = min(dp[!parity][i + 1], 1 + dp[parity][prev + 1]);
						bestv[!parity] = tmp;
					}
				}

			}
		}

		//curv = lastv;

		for (int k = 0; k < 2; ++k) {
			if (bestv[k] == -1) {
				bestv[k] = curv;
			}
		}

		for (int j = 1; j >= 0; --j) {
			if (dp[j][i + 1] == INF) {
				cout << j - 2 << " ";
			}
			else {
				cout << dp[j][i + 1] << " ";
			}
		}
		
		cout << "\n";
	}

}


void solve() {
	init();
	cin >> s;
	build();

}