#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>

using namespace std;

string s[2];
struct vert
{
	int a[26];
	int suff, depth, cnt;
} bor[2][200005];

void init(int t)
{
	bor[t][0].suff = 0;
	bor[t][1].suff = 0;
	bor[t][0].depth = -1;
	bor[t][1].depth = 0;
	
	
	memset(bor[t][1].a, -1, sizeof(bor[t][1].a));
	memset(bor[t][0].a, -1, sizeof(bor[t][0].a));
	memset(bor[t][200004].a, -1, sizeof(bor[t][200004].a));
}
int ans1, ans2, ans3;
int q = 0;
void dfs(int v, int u)
{
	//cout << v << " " << u << " " << bor[0][v].cnt << " " << bor[1][u].cnt << endl;
	if (bor[0][v].cnt > bor[1][u].cnt)
		ans1++;
	if (bor[0][v].cnt < bor[1][u].cnt)
		ans3++;
	if (bor[0][v].cnt == bor[1][u].cnt && bor[0][v].cnt != 0)
		ans2++;
	
	
	for(int i = 0; i < 26; i++)
	{
		if (bor[0][v].a[i] != -1 && bor[1][u].a[i] != -1)
		{
			dfs(bor[0][v].a[i], bor[1][u].a[i]);
		} else if (bor[0][v].a[i] == -1 && bor[1][u].a[i] != -1)
		{
			dfs(200004, bor[1][u].a[i]);
		} else if (bor[0][v].a[i] != -1 && bor[1][u].a[i] == -1) {
			dfs(bor[0][v].a[i], 200004);
		}
	}
}

void ddfs(int t, int v)
{
	for(int i = 0; i < 26; i++)
	{
		if (bor[t][v].a[i] != -1) {
			ddfs(t, bor[t][v].a[i]);
				
		}
	}
	if (bor[t][v].suff > 1) 
		bor[t][bor[t][v].suff].cnt += 2 * bor[t][v].cnt;
		
}

int main() {
	int qwe;
	cin >> qwe;
	for(int qwer = 0; qwer < qwe; qwer++)
	{
		cin >> s[0] >> s[1];
		for(int t = 0; t < 2; t++)
		{
			int cur = 0;
			init(t);
			int fr = 2;
			for(int i = 0; i < s[t].size(); i++)
			{
				s[t][i] = s[t][i] - 'a';
				//cout << i << " " << cur << " " << i - bor[t][cur].depth - 1  << endl;
				while (i - bor[t][cur].depth - 1 < 0 || s[t][i] != s[t][i - bor[t][cur].depth - 1])
				{
					cur = bor[t][cur].suff;
					
				}
				if (bor[t][cur].a[s[t][i]] != -1)
				{
					cur = bor[t][cur].a[s[t][i]];
					bor[t][cur].cnt++;
				} else {
					bor[t][cur].a[s[t][i]] = fr;
					bor[t][fr].depth = bor[t][cur].depth + 2;
					if (bor[t][fr].depth == 1) {
						bor[t][fr].suff = 1;
					} else {
						cur = bor[t][cur].suff;
						while (i - bor[t][cur].depth - 1 < 0 || s[t][i] != s[t][i - bor[t][cur].depth - 1])
							cur = bor[t][cur].suff;
						bor[t][fr].suff = bor[t][cur].a[s[t][i]];
					}
					bor[t][fr].cnt = 1;
					memset(bor[t][fr].a, -1, sizeof(bor[t][fr].a));
					cur = fr;					
					fr++;
				} 	
			}
			ddfs(t, 0);
			ddfs(t, 1);
		}
		ans1 = ans2 = ans3 = 0;
		dfs(0, 0);
		dfs(1, 1);
		cout << "Case #" << qwer + 1<< ": " << ans1 << " " << ans2 << " " << ans3 << endl;
		//cout << endl;
	}
    return 0;
}
