#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

const int N = 3e5;

struct Input {
	string s;
	
	bool read () {
		return getline(cin, s);
		
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	ll ans;
	
	void write () {
		cout << ans << "\n";
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

const int ALPHA = 26;

struct tree {
	tree(){}
    struct item {
    	int next[ALPHA];
    	int link;
    	int len;
    	int cnt;
    	item() {
    		memset(next, -1, sizeof(next));
    		link = 1;
    		len = -1;
    		cnt = 0;
    	}
    };

    item a[N + 2];
    int lst, sz;
    int s[N];

    int add (int tekc, int n) {
    	int cur = lst;
    	while (s[n] != s[n - a[cur].len - 1]) {
    		cur = a[cur].link;
    	}
    	if (a[cur].next[tekc] != -1) {
    		lst = a[cur].next[tekc];
    		return a[lst].cnt;
    	}
    	lst = sz;
    	a[cur].next[tekc] = sz;
    	a[sz].len = a[cur].len + 2; 
    	a[sz].cnt = 1;
    	cur = a[cur].link;
    	while (s[n] != s[n - a[cur].len - 1]) {
    		cur = a[cur].link;
    	}
    	if (a[sz].len > 1) {
    		a[sz].link = a[cur].next[tekc];
    	}
    	a[sz].cnt += a[a[sz].link].cnt;
    	sz++;
    	return a[lst].cnt;
    }
    
    void init(int n, const char *b) {
    	forn(i, n + 2) {
    		a[i] = item();
    	}
    	forn(i, n) {
    		s[i] = b[i] - 'a';
    	}
    	a[0].link = a[1].link = 0;
    	a[1].len = 0;
    	sz = 2;
    	lst = 0;
    }
};

struct Solution: Data {
	tree t[2];
	int a[2][N];
	char buf[N];
	
	void solve () {
		forn (k, 2) {
			forn (i, sz(s)) {
				buf[i] = s[i] - 'a';
			}
			t[k].init(sz(s), buf);
			forn (i, sz(s)) {
				a[k][i] = t[k].add(buf[i], i);
			}
			reverse(all(s));
		}
		
		ans = 0;
		for (int i = 0; i + 1 < sz(s); ++i) {
			ans += ll(a[0][i]) * a[1][sz(s) - i - 2];
		}	
	}
	
	void clear () {
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("b.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
