#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

const int N = 200100;

struct Input {
	char c[2][N];
	
	bool read () {
		gets(c[0]);
		gets(c[1]);
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	
	int ans1, ans2, ans3;
	
	void write () {
		printf ("%d %d %d\n", ans1, ans2, ans3);
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

const int ALPHA = 26;

struct Solution: Data {
	vector <int> g[N];
	
	struct item {
    	int next[ALPHA];
    	int link;
    	int len;
    	int cnt;
    	int msk;
    	item() {
    		memset(next, -1, sizeof(next));
    		link = 1;
    		len = -1;
    		cnt = 0;
    		msk = 0;
    	}
    };
    
	item a[2][N + 2];	
    int lst[2], sz[2];

    bool add (int tekc, int n, int idx) {
    	int cur = lst[idx];
    	while (n - a[idx][cur].len - 1 < 0 || c[idx][n] != c[idx][n - a[idx][cur].len - 1]) {
    		cur = a[idx][cur].link;
    	}
    	if (a[idx][cur].next[tekc] != -1) {
    		lst[idx] = a[idx][cur].next[tekc];
    		a[idx][a[idx][cur].next[tekc]].cnt++;
    		return 0;
    	}
    	lst[idx] = sz[idx];
    	a[idx][cur].next[tekc] = sz[idx];
    	a[idx][cur].msk |= 1 << tekc;
    	a[idx][sz[idx]].len = a[idx][cur].len + 2; 
    	a[idx][sz[idx]].cnt = 1;
    	cur = a[idx][cur].link;
    	
    	while (n - a[idx][cur].len - 1 < 0 || c[idx][n] != c[idx][n - a[idx][cur].len - 1]) {
    		cur = a[idx][cur].link;
    	}
    	
    	if (a[idx][sz[idx]].len > 1) {
    		a[idx][sz[idx]].link = a[idx][cur].next[tekc];
    	}
    	sz[idx]++;
    	return 1;
    }

    void init(int n, int idx) {
    	forn(i, n + 2) {
    		a[idx][i] = item();
    	}
    	a[idx][0].link = a[idx][1].link = 0;
    	a[idx][1].len = 0;
    	sz[idx] = 2;
    	lst[idx] = 0;
    }
	
	int dfs (int v, int idx) {
		int cnt = a[idx][v].cnt;
		forn(i, g[v].size()) {
			int to = g[v][i];
			cnt += dfs(to, idx);
		}
		return a[idx][v].cnt = cnt;
	}
	
	void calc (int u, int v) {
		if (v != 0 && v != 1) {
			if (a[0][u].cnt < a[1][v].cnt) {
				ans3++;
			} else if (a[1][v].cnt < a[0][u].cnt) {
				ans1++;
			} else {
				ans2++;
			}
		}
		int val = a[0][u].msk & a[1][v].msk;
		while (val) {
			int i = __builtin_ctz(val);
			calc(a[0][u].next[i], a[1][v].next[i]);
			val -= (1 << i);
		}
		val = a[0][u].msk & ~a[1][v].msk;
		while (val) {
			int i = __builtin_ctz(val);
			calc2(a[0][u].next[i], 0, ans1);
			val -= (1 << i);
		}
		val = a[1][v].msk & ~a[0][u].msk;
		while (val) {
			int i = __builtin_ctz(val);
			calc2(a[1][v].next[i], 1, ans3);
			val -= (1 << i);
		}
	}
	
	void calc2 (int v, int idx, int& ans) {
		ans++;
		int val = a[idx][v].msk;
		while (val) {
			int i = __builtin_ctz(val);
			calc2(a[idx][v].next[i], idx, ans);
			val -= (1 << i);
		}
	}
	
	void solve () {
		ans1 = ans2 = ans3 = 0;
		forn(i, 2) {
			int n = strlen(c[i]);
			forn(j, n) {
				c[i][j] -= 'a';
			}	
			init(n, i);	
			forn(j, n) {
				add(c[i][j], j, i);
			}
			forn(j, n + 2) {
				if (j > 0)
					g[a[i][j].link].pb(j);
			}
			dfs(0, i);
			forn(j, n + 2) {
				g[j] = vector<int>();
			}
		}
		forn(i, 2) {
			calc(i, i);
		}
	}
	
	void clear () {
	}
};

Solution sol;

Input in;

/*void gen (char *c) {
	int s = 200000;
	forn (i, s) {
		c[i] = rand() % 26 + 'a';
	}
	c[s] = 0;
}

void gen () {
	gen(in.a[0]);
	gen(in.a[1]);
}*/

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("d.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
#endif/*
	for (int i = 0; 1; ++i) {
		gen();
		sol.init(in);
		sol.solve();
		if (i % 20 == 0) {
			sol.write();
			debug(clock());
		}
		sol.clear();
	}
	return 0;
	*/
	int t;
	cin >> t;
	string qwe;
	getline(cin, qwe);
	forn(i, t) {
		sol.read();
		sol.solve();
		printf ("Case #%d: ", i + 1);
		sol.write();
		sol.clear();
	}

	return 0;
}
