#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int size = 500 * 1000;

int tc;
int way[size][26];
int suflink[size];
int ts = 0;
int len[size];
int cur;
int cnt[2][size];

void init() {
	for (int i = 0; i < ts; i++) {
		for (int j = 0; j < 26; j++)
			way[i][j] = 0;
		suflink[i] = 0;
		len[i] = 0;
		cnt[0][i] = cnt[1][i] = 0;
	}
	
	len[0] = -1;
	len[1] = 0;
	suflink[1] = 0;
	suflink[0] = -1;
	ts = 2;
	cur = 0;
}

char str[2][size];

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));

	scanf("%d", &tc);
	for (int tnum = 0; tnum < tc; tnum++) {
		scanf("%s%s", str[0], str[1]);

		init();
		for (int i = 0; i < 2; i++) {
			int n = strlen(str[i]);
			cur = 0;

			for (int j = 0; j < n; j++) {
				while (j - len[cur] - 1 < 0 || str[i][j] != str[i][j - len[cur] - 1])
					cur = suflink[cur];

				if (way[cur][str[i][j] - 'a'] == 0) {
					way[cur][str[i][j] - 'a'] = ts;
					len[ts] = len[cur] + 2;
					int h = suflink[cur];
					while (h != -1 && (str[i][j] != str[i][j - len[h] - 1] || way[h][str[i][j] - 'a'] == 0))
						h = suflink[h];
					if (h == -1)
						suflink[ts] = 1;
					else
						suflink[ts] = way[h][str[i][j] - 'a'];
					ts++;
				} 

				cur = way[cur][str[i][j] - 'a'];
				cnt[i][cur]++;

			}

		}

		for (int i = ts - 1; i > 0; i--)
			for (int j = 0; j < 2; j++)
				cnt[j][suflink[i]] += cnt[j][i];

		int a = 0, b = 0, c = 0;
		for (int i = 2; i < ts; i++) {
			a += (cnt[0][i] < cnt[1][i]);
			b += (cnt[0][i] == cnt[1][i]);
			c += (cnt[0][i] > cnt[1][i]);
		}

		printf("Case #%d: %d %d %d\n", tnum + 1, c, b, a);
	}

	return 0;
}