#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 500100;

#define link slhfdskfh_link

int to[MAXN][26];
int link[MAXN];
int len[MAXN];
int num;
int sufH[MAXN];
char s[MAXN];
int cnt[MAXN], revcnt[MAXN];

void
clear(int v)
{
	link[v] = 0;
	len[v] = 0;
	for (int i = 0; i < 26; ++i) {
		to[v][i] = 0;
	}
}

void
init()
{
	num = 2;
	clear(1);
	clear(2);
	sufH[1] = sufH[2] = 0;
	link[1] = link[2] = 1;
	len[1] = -1;
	len[2] = 0;
}

void
add(char *s, int mlen, int *cc)
{
	int curId = 2;
	for (int i = 0; i < mlen; ++i) {
		while (i - len[curId] - 1 < 0 || s[i - len[curId] - 1] != s[i]) {
			curId = link[curId];
		}
		if (to[curId][s[i] - 'a'] == 0) {
			++num;
			to[curId][s[i] - 'a'] = num;
			clear(num);
			len[num] = len[curId] + 2;
			int secondId = link[curId];
			while (i - len[secondId] - 1 < 0 || s[i - len[secondId] - 1] != s[i]) {
				secondId = link[secondId];
			}
			if (to[secondId][s[i] - 'a'] == 0) {
				++num;
				to[secondId][s[i] - 'a'] = num;
				clear(num);
				len[num] = len[secondId] + 2;
			}
			secondId = to[secondId][s[i] - 'a'];
			curId = to[curId][s[i] - 'a'];
			link[curId] = secondId;
			if (curId == secondId) {
				link[curId] = 2;
			}
			sufH[curId] = sufH[link[curId]] + 1;
		} else {
			curId = to[curId][s[i] - 'a'];
		}
		cc[i] = sufH[curId];
	}
}

void
process(int tid)
{
	scanf(" %s", s);
	init();
	add(s, strlen(s), cnt);
	reverse(s, s + strlen(s));
	init();
	add(s, strlen(s), revcnt);
	reverse(s, s + strlen(s));
	reverse(revcnt, revcnt + strlen(s));
	ll res = 0ll;
	int lens = strlen(s);
	for (int i = 0; i < lens - 1; ++i) {
		res += 1ll * cnt[i] * revcnt[i + 1];
	}
	printf("%lld\n", res);
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	int t = 1;
	//scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process(i + 1);
	}

	return 0;
}