#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

const int SIGMA = 26;

struct Node {
    int go[SIGMA], len, link, plen;
};

const int MAXN = 300 * 1000 + 5;
Node pt[MAXN];
int l[MAXN], r[MAXN], freeNode, suff;

int newNode(int len, int link, int plen) {
    for(int i = 0; i < SIGMA; i++)
        pt[freeNode].go[i] = -1;
    pt[freeNode].len = len;
    pt[freeNode].link = link;
    pt[freeNode].plen = plen;
    return freeNode++;
}

void add(int pos, string &s, bool b) {
    while(pos - pt[suff].len - 1 < 0 || s[pos - pt[suff].len - 1] != s[pos])
        suff = pt[suff].link;
    if(pt[suff].go[s[pos] - 'a'] == -1) {
        int link = pt[suff].link;
        while(pos - pt[link].len - 1 < 0 || s[pos - pt[link].len - 1] != s[pos])
            link = pt[link].link;
        link = max(1, pt[link].go[s[pos] - 'a']);
        pt[suff].go[s[pos] - 'a'] = newNode(pt[suff].len + 2, link, pt[link].plen + 1);
    }
    suff = pt[suff].go[s[pos] - 'a'];
    if(b)
        l[pos] = pt[suff].plen;
    else
        r[(int)s.length() - pos - 1] = pt[suff].plen;
}

int main() {
    ios_base::sync_with_stdio(false);
    string s;
    cin >> s;
    newNode(-1, 0, 0);
    newNode(0, 0, 0);
    for(size_t i = 0; i < s.length(); i++)
        add(i, s, true);
    reverse(s.begin(), s.end());
    freeNode = 0;
    suff = 0;
    for(size_t i = 0; i < s.length(); i++)
        add(i, s, false);
    long long ans = 0;
    for(size_t i = 0; i + 1 < s.length(); i++)
        ans += (long long)l[i] * r[i + 1];
    cout << ans << '\n';
    return 0;
}
