#include <iostream>
#include <string>
#include <algorithm>
#include <cassert>

using namespace std;

struct Node {
	char len;
	bool in;
	int suffix;
	int child[2];
};

Node nodes[500005];
int nodecount;

uint64_t S = 0;
int n;

int compute(int node, int i) {
		int innode = node;
		while(i - 1 - nodes[innode].len < 0 || ((S >> (i - 1 - nodes[innode].len)) & 1) != ((S >> i) & 1)) {
			innode = nodes[innode].suffix;
		}
		if(nodes[innode].child[(S >> i) & 1]) {
			node = nodes[innode].child[(S >> i) & 1];
		} else {
			int newnode = nodecount++;
			nodes[innode].child[(S >> i) & 1] = newnode;
			nodes[newnode].len = nodes[innode].len + 2;
			
			if(nodes[newnode].len == 1) {
				nodes[newnode].suffix = 1;
			} else {
				innode = nodes[innode].suffix;
				while(i - 1 - nodes[innode].len < 0 || ((S >> (i - 1 - nodes[innode].len)) & 1) != ((S >> i) & 1)) {
					innode = nodes[innode].suffix;
				}
				nodes[newnode].suffix = nodes[innode].child[(S >> i) & 1];
			}
			
			node = newnode;
		}
	return node;
}

int N;
int64_t counts[100];

void asd(int i, int node) {
	++counts[i];
	if(i == N) return;
	for(char c = 0; c < 2; ++c) {
		if(i == 0 && c == 1) continue;
		if(c) {
			S |= 1 << i;
		} else {
			S &= ~(1 << i);
		}
		int node2 = compute(node, i);
		if(nodes[node2].in) continue;
		int x = node2;
		while(x >= 2 && !nodes[x].in) {
			nodes[x].in = true;
			x = nodes[x].suffix;
		}
		asd(i + 1, node2);
		int y = node2;
		while(y != x) {
			nodes[y].in = false;
			y = nodes[y].suffix;
		}
	}
}

int main() {
	fill((char*)nodes, (char*)nodes + 500005 * sizeof(Node), 0);

	nodecount = 2;
	nodes[0].len = -1;
	nodes[0].suffix = 0;
	nodes[1].len = 0;
	nodes[1].suffix = 0;
	
	cin >> N;
	
	asd(0, 1);
	
	for(int i = 1; i <= N; ++i) {
		cout << 2 * counts[i] << "\n";
	}
	
	return 0;
}
