#include <stdio.h>
#include <algorithm>
#include <iostream>
#include <string.h>
#include <vector>

using namespace std;

const int N = 600000;

struct Node {
	int next[28];
	int suff, sz;
	int num;
	Node () {
		memset(next, -1, sizeof(next));
		num = 0;
	}
};

vector<Node> tr;
bool flag;
int last, n, cnt, tt, a0, a1, a2, el[N];
string s;
char buff[N];

void init(int n) {
	tr.clear();
	tr.resize(n + 5);
	cnt = 2;
	last = 1;
	tr[0].sz = -1; tr[0].suff = 0;
	tr[1].sz = 0; tr[1].suff = 0;
}

bool add(int i) {
//	cerr << last << ": " << tr[last].sz << " " << tr[last].suff << endl;
	int cur = last;
	while ((i - tr[cur].sz - 1 < 0) || (s[i - tr[cur].sz - 1] != s[i])) {
		cur = tr[cur].suff;
	}
	int let = s[i] - 'a';
	if (tr[cur].next[let] != -1) {
		last = tr[cur].next[let];
		return false;
	}
	int x = cnt++;
	last = x;
	tr[x].sz = tr[cur].sz + 2;
	tr[cur].next[let] = x;
	if (tr[x].sz == 1) {
		tr[x].suff = 1;
		tr[x].num = 1;
		return true;
	}
	cur = tr[cur].suff;
	while ((i - tr[cur].sz - 1 < 0) || (s[i - tr[cur].sz - 1] != s[i])) {
		cur = tr[cur].suff;
	}
	cur = tr[cur].next[let];
	tr[x].suff = cur;
	tr[x].num = tr[tr[x].suff].num + 1;
	return true;
}

int main() {
	freopen("input.txt", "r", stdin);
	tt = 1;
	while (tt--) {
		gets(buff);
		buff[strlen(buff)] = 0;
		s = string(buff);
		init(s.size());
		for (int i = 0; i < s.size(); i++) {
			add(i);
			el[i] = last;
		}
		last = 1;
		reverse(s.begin(), s.end());
		long long ans = 0;
		for (int i = 0; i < s.size(); i++) {
			add(i);
			if (i + 1 < s.size()) {
				int j = s.size() - i - 2;
				ans += tr[last].num * 1LL * tr[el[j]].num;
			}
		}
		printf("%lld\n", ans);
	}
	puts("");
}