#include <stdio.h>
#include <algorithm>
#include <iostream>
#include <string.h>
#include <vector>

using namespace std;

const int N = 400000;
const int INF = 1e9;

struct Node {
	int next[28];
	int suff, sz, bsuff, csuff[2], diff;
	int num[2];
	Node () {
		memset(next, -1, sizeof(next));
		num[0] = num[1] = 0;
	}
	void print() {
		printf("%d %d\n", csuff[0], csuff[1]);
	}
};

vector<Node> tr;
bool flag;
int last, n, cnt, tt, a0, a1, a2, f[N][2];
string s;
char buff[N];

void init(int n) {
	tr.clear();
	tr.resize(n + 5);
	cnt = 2;
	last = 1;
	tr[0].sz = -1; tr[0].suff = 0; tr[0].bsuff = 0; 
	tr[0].csuff[0] = tr[0].csuff[1] = INF;
	tr[1].sz = 0; tr[1].suff = 0; tr[1].bsuff = 0; 
	tr[1].csuff[0] = tr[1].csuff[1] = INF;
}

bool add(int i) {
	int cur = last;
	while ((i - tr[cur].sz - 1 < 0) || (s[i - tr[cur].sz - 1] != s[i])) {
		cur = tr[cur].suff;
	}
	int let = s[i] - 'a';
	if (tr[cur].next[let] != -1) {
		last = tr[cur].next[let];
		return false;
	}
	int x = cnt++;
	last = x;
	tr[x].sz = tr[cur].sz + 2;
	tr[cur].next[let] = x;
	if (tr[x].sz == 1) {
		tr[x].suff = 1;
		tr[x].bsuff = 1;
		tr[x].diff = 1;
		return true;
	}
	cur = tr[cur].suff;
	while ((i - tr[cur].sz - 1 < 0) || (s[i - tr[cur].sz - 1] != s[i])) {
		cur = tr[cur].suff;
	}
	cur = tr[cur].next[let];
	tr[x].diff = tr[x].sz - tr[tr[x].suff].sz;
	tr[x].suff = cur;
	tr[x].bsuff = tr[x].diff == tr[tr[x].suff].diff ? tr[tr[x].suff].bsuff : tr[x].suff;
	return true;
}

void recalc(int x, int pos) {
	vector<int> v;
	for (int i = x; i > 0; i = tr[i].bsuff) v.push_back(i);
	reverse(v.begin(), v.end());
	for (int it = 1; it < v.size(); it++) {
		int i = v[it];
		int cpos = pos - tr[i].sz;
		if (cpos < 0) {
			tr[i].csuff[1] = 0;
			tr[i].csuff[0] = INF;
		} else {
			tr[i].csuff[0] = f[cpos][0];
			tr[i].csuff[1] = f[cpos][1];
		}
		int j = tr[i].bsuff;
		tr[i].csuff[0] = min(tr[i].csuff[0], tr[j].csuff[0]);
		tr[i].csuff[1] = min(tr[i].csuff[1], tr[j].csuff[1]);
	}
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	gets(buff);
	buff[strlen(buff)] = 0;
	s = string(buff);
	init(s.size());
	for (int i = 0; i < s.size(); i++) {
		add(i);
		recalc(last, i);
		f[i][0] = f[i][1] = INF;
		for (int j = last; j > 0; j = tr[j].bsuff) {
//			tr[j].print();
			f[i][0] = min(f[i][0], tr[j].csuff[0]);
			f[i][1] = min(f[i][1], tr[j].csuff[1]);
		}
//		return 0;
		swap(f[i][0], f[i][1]);
		f[i][0]++;
		f[i][1]++;
		printf("%d %d\n", f[i][0] >= INF ? -1 : f[i][0], f[i][1] >= INF ? -2 : f[i][1]);
	}
}
