#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

//#include <unordered_set>
//
//int submask(int mask, int l, int r)
//{
//    mask >>= l;
//    r -= l;
//    int stamp = (~((~0) << (r + 1)));
//    int res = stamp & mask;
//    return res;
//}
//
//int bit(int x, int i)
//{
//    return (x & (1 << i)) > 0;
//}
//
//bool is_pal(int x, int len)
//{
//    int to = min(len, (len / 2) + 2);
//    for (int i = 0; i < to; ++i)
//        if (bit(x, i) != bit(x, len - i - 1))
//            return false;
//    return true;
//}
//
//int get(int n)
//{
//    int res = 0;
//
//    const int maxn = 1 << n;
//
//    for (int mask = 0; mask < maxn; ++mask)
//    {
//        vector< unordered_set<int> > cnt(n + 1);
//
//        for (int i = 0; i < n; ++i)
//            for (int j = i; j < n; ++j)
//            {
//                int sub = submask(mask, i, j);
//                if (is_pal(sub, j - i + 1))
//                    cnt[j - i + 1].insert(sub);
//            }
//
//        int cur = 0;
//        forn(i, cnt.size())
//            cur += cnt[i].size();
//
//        res += cur == n;
//    }
//
//
//    return res;
//}

//LL solve(int n)
//{
//   LL res = 0;
//    for (int i = 0; i < (1 << n); i++)
//    { 
//        LL cnt = 0;
//        set<vector<int> > sp;
//        for (int l = 0; l < n; l++)
//        {  
//            vector <int> q;
//            for (int r = l; r < n; r++)
//            {
//                q.pb(((i >> r) & 1) > 0);
//                
//                bool fl = true;
//                int d  = r - l + 1;
//                for (int k = 0; k < d / 2; k++)
//                    if (q[k] != q[d - 1 - k])
//                    {
//                        fl = false;
//                        break;
//                    }
//
//                if (fl)
//                {
//                    sp.insert(q);
//                }
//            }
//        }
//        if (sp.size() == n)
//            res++;
//
//    }
//    return res;
//}

void solve()
{
    int res[27] = {
    0          ,
    2          ,
    4          ,
    8          ,
    16         ,
    32         ,
    64         ,
    128        ,
    252        ,
    488        ,
     932       ,
     1756      ,
     3246      ,
     5916      ,
     10618     ,
     18800     ,
     32846     ,
     56704     ,
     96702     ,
     163184    ,
     272460    ,
     450586    ,
     738274    ,
     1199376   ,
     1932338   ,
     3089518   ,
     4903164};

    int n; cin >> n;
    for (int i = 1; i <= n; ++i)
        cout << res[i] << endl;
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);

    solve();


    //dbg(submask(7, 0, 2));
    //dbg(submask(7, 0, 1));

//    cout << 1 << " " << solve(1) << endl;
    //freopen("zzz.txt", "w", stdout);
    //for (int i = 27; i <= 35; i++)
    //    cout << i << " " <<  get(i) << endl;
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif