#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <map>
using namespace std;



const int maxn = (int) 1e6 + 100;
char str[maxn];


map <char, int> go[maxn];
int suffLink[maxn];
int len[maxn];
int cntSuff[maxn];
int numV = 0;

void init()
{
	len[0] = -1;
	len[1] = 0;
	suffLink[1] = 0;
	suffLink[0] = 0;
	numV = 2;
//	for (int i = 0; i < 200; i++)
//	{
//		go[0][ (char) i] = numV;
//		suffLink[numV] = 1;
//		numV++;
//	}
}

int addLetter(int v, int i)
{
	while (str[i] != str[i - len[v] - 1] )
		v = suffLink[v];
//	fprintf(stderr, "v = %d, i = %d\n", v, i);
	if (go[v].count(str[i] ) != 0)
		return go[v][str[i] ];
	
	int _v = v;
	v = go[v][str[i] ] = numV++;
	len[v] = len[_v] + 2;
	_v = suffLink[_v];
	while (str[i] != str[i - len[_v] - 1] )
		_v = suffLink[_v];
	if (len[v] == 1)
		_v = 1;
	else
		_v = go[_v][str[i] ];
	suffLink[v] = _v;
	cntSuff[v] = cntSuff[_v] + 1;
	return v; 
}

int lft[maxn], rght[maxn];

void printT(int v, string sp)
{
	printf("%s : %d - - -> %d   cnt = %d\n", sp.c_str(), v, suffLink[v], cntSuff[v] );
	for (auto it = go[v].begin(); it != go[v].end(); it++)
	{
		string nsp = sp;
		nsp.push_back(it->first);
		printT(it->second, nsp);
	}
}

void printTree()
{
	printT(0, "");
	printT(1, "");
}


int main()
{
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	init();
	scanf("%s", str + 1);
	int n = strlen(str + 1);
	str[0] = -1;

	int v = 1;
	for (int i = 0; i < n; i++)
	{
		v = addLetter(v, i + 1);
		lft[i] = cntSuff[v];
//		printf("%d ", cntSuff[v] );
	}
//	printf("\n");
//	printTree();
	reverse(str + 1, str + n + 1);
	v = 1;
	for (int i = 0; i < n; i++)
	{
		v = addLetter(v, i + 1);
		rght[n - i - 1] = cntSuff[v];
//		printf("(%d, %d) ", v, rght[n - i - 1] );
	}
//	printf("\n");
	long long ans = 0;
	for (int i = 0; i < n; i++)
		ans += lft[i] * 1LL * rght[i + 1];

	printf("%lld\n", ans);

	return 0;
}

