#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

struct node {
	int link;
	int len;
	int cnt;
	int to[2];
	node() {
		memset(to,-1,sizeof(to));
	}
};

const int maxn = 70;
char s[maxn];

node t[maxn+5];
int mem;

bool solve(int n) {
	mem = 0;
	node root0, root1;
	root0.len = 0;
	root0.link = 1;
	root1.len = -1;
	root1.link = 1;
	root0.cnt = root1.cnt = 0;
	t[mem++] = root0;
	t[mem++] = root1;
	int lst = 0;
	forn(i, n) {
		int ch = s[i];
		while (i-t[lst].len-1 < 0 || s[i-t[lst].len-1] != s[i]) lst = t[lst].link;
		if (t[lst].to[ch] == -1) {
			int pr = t[lst].link;
			while (s[i-t[pr].len-1] != s[i]) pr = t[pr].link;
			node cur;
			cur.len = t[lst].len + 2;
			cur.link = t[pr].to[ch];
			if (cur.len == 1) cur.link = 0;
			cur.cnt = t[cur.link].cnt+1;
			t[lst].to[ch] = mem;
			t[mem++] = cur;
		} else return false;
		lst = t[lst].to[ch];
	}
	return true;
}

int ans;

int A[40];

const int TO = 25;

void rec(int pos) {
	if (pos == TO+1) return;
	bool cur = solve(pos);
	A[pos] += cur;
	if (cur) {
		forn(i, 2) {
			s[pos] = i;
			rec(pos+1);
		}
	}
}





int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	A[1] = 2;
A[2] = 4;
A[3] = 8;
A[4] = 16;
A[5] = 32;
A[6] = 64;
A[7] = 128;
A[8] = 252;
A[9] = 488;
A[10] = 932;
A[11] = 1756;
A[12] = 3246;
A[13] = 5916;
A[14] = 10618;
A[15] = 18800;
A[16] = 32846;
A[17] = 56704;
A[18] = 96702;
A[19] = 163184;
A[20] = 272460;
A[21] = 450586;
A[22] = 738274;
A[23] = 1199376;
A[24] = 1932338;
A[25] = 3089518;
A[26] = 4903164;
A[27] = 7728120;
A[28] = 12099440;
A[29] = 18825066;
A[30] = 29112876;
	//rec(0);
	int n; scanf("%d", &n);
	for (int i = 1; i <= n; ++i) printf("%d\n", A[i]);
	//for(n = 1; n <= 26; ++n) {
	//	ans = 0;
	//	rec(0);
	//	cerr << n << " " << ans << "\n";
	//	cout << "A[" << n << "] = " << ans << ";\n";
	//}
	return 0;
}

//A[1] = 2;
//A[2] = 4;
//A[3] = 8;
//A[4] = 16;
//A[5] = 32;
//A[6] = 64;
//A[7] = 128;
//A[8] = 252;
//A[9] = 488;
//A[10] = 932;
//A[11] = 1756;
//A[12] = 3246;
//A[13] = 5916;
//A[14] = 10618;
//A[15] = 18800;
//A[16] = 32846;
//A[17] = 56704;
//A[18] = 96702;
//A[19] = 163184;
//A[20] = 272460;
//A[21] = 450586;
//A[22] = 738274;
//A[23] = 1199376;
//A[24] = 1932338;
//A[25] = 3089518;
//A[26] = 4903164;
