#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

struct node {
	int link;
	int len;
	int cnt;
	int to[27];
	node() {
		memset(to,-1,sizeof(to));
	}
};

const int maxn = 300010;
node t[maxn];
int mem;

int dpeven[maxn];
int dpodd[maxn];

const int cinf = 1000000010;

void solve(string s) {
	dpeven[0] = cinf;
	dpodd[0] = 1;

	mem = 0;
	forn(i, sz(s)) s[i] -= 'a';
	node root0, root1;
	root0.len = 0;
	root0.link = 1;
	root1.len = -1;
	root1.link = 1;
	root0.cnt = root1.cnt = 0;
	t[mem++] = root0;//t.pb(root0);
	t[mem++] = root1;//t.pb(root1);
	int lst = 0;
	int n = sz(s);
	forn(i, n) {
		int ch = s[i];
		while (i-t[lst].len-1 < 0 || s[i-t[lst].len-1] != s[i]) lst = t[lst].link;
		if (t[lst].to[ch] == -1) {
			
			int pr = t[lst].link;
			while (s[i-t[pr].len-1] != s[i]) pr = t[pr].link;
			node cur;
			cur.len = t[lst].len + 2;
			cur.link = t[pr].to[ch];
			if (cur.len == 1) cur.link = 0;
			cur.cnt = t[cur.link].cnt+1;
			t[lst].to[ch] = mem;
			t[mem++] = cur;
			//t.pb(cur);
		}
		lst = t[lst].to[ch];
		if (i > 0) {
			int x = min(dpeven[i-1], dpodd[i-1]);
			int fr = max(1,x-1);
			int to = min(i+1,x+1);
			for (int cc = fr; cc <= to; ++cc) {
				const int MAGIC = 400;
				int cur = lst;
				for (int iter = 0, cur = lst; iter < MAGIC; cur = t[cur].link, ++iter) {
					if (cur < 2) break;
					int curlen = t[cur].len;
					if (curlen == i+1) {
						dpodd[i] = 1;
						continue;
					}
					int tev = dpeven[i-curlen];
					int todd = dpodd[i-curlen];
					dpeven[i] = min(dpeven[i], todd+1);
					dpodd[i] = min(dpodd[i], tev+1);
				}
			}
		}
	}
}



int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	forn(i, maxn) dpeven[i] = cinf, dpodd[i] = cinf;
	string s; cin >> s;
	solve(s);
	forn(i, sz(s)) {
		int c1 = dpodd[i];
		int c2 = dpeven[i];
		if (c1 == cinf) c1 = -1;
		if (c2 == cinf) c2 = -2;
		printf("%d %d\n", c1,c2);
	}
	return 0;
}
