#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e6+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

string s;
int d1[maxn], d2[maxn], d[maxn];
ll a[maxn], b[maxn];

void manacher(string &s){
	string t = "#";
	for (int i=0;i<s.length();i++){
		t += s[i];
		t += "#";
	}
	int tn = t.length();
	d[0] = 1;
	for (int i=1, j = 0;i<tn;i++){
		d[i] = 1;
		if ( j + d[j] > i ) d[i] = min(d[j-(i-j)], j + d[j] - i);
		while ( i - d[i] >= 0 && i + d[i] < tn && t[i-d[i]] == t[i+d[i]] ) d[i]++;
		if ( i + d[i] > j + d[j] ) j = i;
	}

	for (int i=0;i<s.length();i++){
		d2[i] = d[2*i]/2;
		d1[i] = d[2*i+1]/2;
	}

}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif


	cin >>s;

	manacher(s);

	int n = sz(s);

	for(int i = 0; i < n; i++) {
		int l = i-d1[i]+1, r=i;
		a[l]++; a[r+1]--;
		if(d2[i]) {
			l = i - d2[i];
			r = i-1;
			a[l]++; a[r+1]--;
		}
	}

	ll cur = 0;

	for(int i = 0; i < n; i++) {
		cur += a[i];
		a[i] = cur;
	}
	for(int i = n; i < maxn; i++) a[i] = 0;

	for(int i = n-2; i >= 0; i--) a[i] = a[i] + a[i+1];

	ll ans = 0;

	for(int i = 0; i < n; i++) {
		int l = i+1, r = i + d1[i];
		ans += a[l] - a[r+1];
		if(d2[i]) {
			l = i+1; r = i + d2[i];
			ans += a[l] - a[r+1];
		}
	}

	cout << ans << endl;

	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
