#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "a"

struct Node
{
	map <char, Node*> to;
	Node *suff;
	int len;
	int cnt;
	Node():suff(nullptr), len(0), cnt(0) {}
};

const int MAXN = 1000000;
const int M = MAXN;
const int ALPHA = 256;
Node t[MAXN + 5];

int dir[M], rev[M];
int sz = 4;
Node *last, *odd, *even;


Node *getNextNode()
{
	t[sz] = Node();
	return t + sz++;
}

void append(int pos, const string &s)
{
	Node *cur = last;
	char ch = s[pos];
	while (s[pos - cur->len - 1] != s[pos])
		//cerr << "step" << endl,
		cur = cur->suff;
	
	if (cur->to[ch] != nullptr)
	{
		//cerr << "lol" << endl;
		last = cur->to[ch];
		return;
	}
	
	Node *to = (cur->to[ch] = getNextNode());
	to->len = cur->len + 2;
	if (cur == t)
	{
		to->suff = t + 1;
	} else if (cur == t + 1)
	{
		to->suff = (t + 0)->to[ch];
	} else
	{
		cur = cur->suff;
		assert(cur != nullptr);
		while (s[pos - cur->len - 1] != s[pos])
			cur = cur->suff;
		to->suff = cur->to[ch];
	}
	assert(to->suff != nullptr);
	last = to;
}

void init()
{
	sz = 0;
	odd = getNextNode();
	even = getNextNode();
	
	odd->len = -1;
	even->len = 0;
	
	odd->cnt = 0;
	even->cnt = 0;
	
	odd->suff = nullptr;
	even->suff = odd;
	last = even;
}

pair<int, int> operator+(const pair<int, int> a, const pair<int, int> b)
{
	return pair<int,int>(a.fi + b.fi, a.se + b.se);
}

void printNode(Node *v)
{
	cerr << "NODE # " << (int) (v - t) << "\n";
	for (auto it : v->to)
		cerr << "on char " << it.first << " -> " << (int) (it.second - t) << "\n";
	cerr << "link : " << (int) (v->suff - t) << "\n";
	cerr << "len : " << v->len << "\n";
}

void solve(int testNo)
{
	string a;
	init();
	getline(cin, a);
	a = "!" + a;
	
	for (int i = 1; i < (int) a.length(); ++i)
	{
		append(i, a);
		last->cnt = 1 + last->suff->cnt;
		dir[i] = last->cnt;
	}
	
	init();
	reverse(a.begin() + 1, a.end());
	for (int i = 1; i < (int) a.length(); ++i)
	{
		append(i, a);
		last->cnt = 1 + last->suff->cnt;
		rev[i] = last->cnt;
	}
	
//	for (int i = 1; i < (int) a.length(); ++i)
//		cerr << dir[i] << " ";
//	cerr << "\n";
//	for (int i = 1; i < (int) a.length(); ++i)
//		cerr << rev[i] << " ";
//	cerr << "\n";
	
	long long ans = 0;
	for (int i = 1; i + 1 < (int) a.length(); ++i)
		ans += 1ll * dir[i] * rev[a.length() - i - 1];
	
	cout << ans << "\n";
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	ios_base::sync_with_stdio(false);
	int t;
	string hu;
	t = 1;
	//getline(cin, hu);
	for (int i = 1; i <= t; ++i)
		solve(i);
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
