#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "a"

struct Node
{
	map <char, Node*> to;
	Node *suff;
	int len;
	
	pair<int, int> e;
	
	Node():suff(nullptr), len(0), e(0, 0) {}
};

const int MAXN = 10000000;
const int ALPHA = 256;
Node t[MAXN + 5];

int sz = 4;
Node *last;


Node *getNextNode()
{
	t[sz] = Node();
	return t + sz++;
}

void append(int pos, const string &s)
{
	Node *cur = last;
	char ch = s[pos];
	while (s[pos - cur->len - 1] != s[pos])
		//cerr << "step" << endl,
		cur = cur->suff;
	
	if (cur->to[ch] != nullptr)
	{
		//cerr << "lol" << endl;
		last = cur->to[ch];
		return;
	}
	
	Node *to = (cur->to[ch] = getNextNode());
	to->len = cur->len + 2;
	if (cur == t)
	{
		to->suff = t + 1;
	} else if (cur == t + 1)
	{
		to->suff = (t + 0)->to[ch];
	} else
	{
		cur = cur->suff;
		assert(cur != nullptr);
		while (s[pos - cur->len - 1] != s[pos])
			cur = cur->suff;
		to->suff = cur->to[ch];
	}
	assert(to->suff != nullptr);
	last = to;
}

void init()
{
	sz = 0;
	Node *odd = getNextNode();
	Node *even = getNextNode();
	
	odd->len = -1;
	even->len = 0;
	
	odd->suff = nullptr;
	even->suff = odd;
	last = even;
}

pair<int, int> operator+(const pair<int, int> a, const pair<int, int> b)
{
	return pair<int,int>(a.fi + b.fi, a.se + b.se);
}

void printNode(Node *v)
{
	cerr << "NODE # " << (int) (v - t) << "\n";
	for (auto it : v->to)
		cerr << "on char " << it.first << " -> " << (int) (it.second - t) << "\n";
	cerr << "link : " << (int) (v->suff - t) << "\n";
	cerr << "len : " << v->len << "\n";
}

void solve(int testNo)
{
//	string s;
//	cin >> s;
//	init();
//	s = "!" + s;
//	printNode(t + 0);
//	printNode(t + 1);
//	for (int i = 1; i < (int) s.length(); ++i)
//	{
//		append(i, s);
//		cerr << "I appended " << s[i] << ":\n";
//		printNode(last);
//		continue;
//		cerr << "node no = " << (int) (last - t) << ",\n";
//		printNode(last);
//	}
//	
//	return;
	string a, b;
	init();
	getline(cin, a);
	getline(cin, b);
	a = "!" + a;
	b = "!" + b;
	
	for (int i = 1; i < (int) a.length(); ++i)
	{
		//cerr << a[i] << endl;
		
		append(i, a);
		//cerr << "link = " << (int) (last - t) << "\n";
		last->e.fi++;
	}
	last = t;
	for (int i = 1; i < (int) b.length(); ++i)
	{
		append(i, b);
		last->e.se++;
	}
	//cerr << sz << "!\n";
	for (int i = sz - 1; i > 0; --i)
	if (t[i].suff != nullptr)
	{
		//cerr << i << ": " << t[i].e.fi << " " << t[i].e.se << "\n";
		t[i].suff->e = t[i].suff->e + t[i].e;
	}
	
	int A = 0, B = 0, C = 0;
	for (int i = 0; i < sz; ++i)
		if (t[i].len > 0)
		{
			if (t[i].e.fi > t[i].e.se)
				++A;
			if (t[i].e.fi == t[i].e.se)
				++B;
			if (t[i].e.fi < t[i].e.se)
				++C;
		}
	
	cout << "Case #" << testNo << ": " << A << " " << B << " " << C << "\n";
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	ios_base::sync_with_stdio(false);
	int t;
	string hu;
	cin >> t;
	getline(cin, hu);
	for (int i = 1; i <= t; ++i)
		solve(i);
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
