#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "f"


const int A = 20;

struct Node
{
	map <char, Node*> to;
	Node *suff;
	int len;
	int cnt;
	Node *p[A];
	Node():suff(nullptr), len(0), cnt(0) {}
};

const int MAXN = 1000000;
const int M = MAXN;
const int ALPHA = 256;
Node t[MAXN + 5];

int dir[M], rev[M];
int sz = 4;
Node *last, *odd, *even;


Node *getNextNode()
{
	t[sz] = Node();
	return t + sz++;
}

void calc(Node *v)
{
	v->p[0] = v->suff == nullptr ? v : v->suff;
	for (int i = 1; i < A; ++i)
		v->p[i] = v->p[i - 1]->p[i - 1];
}

void append(int pos, const string &s)
{
	Node *cur = last;
	char ch = s[pos];
	while (s[pos - cur->len - 1] != s[pos])
		cur = cur->suff;
	
	if (cur->to[ch] != nullptr)
	{
		last = cur->to[ch];
		return;
	}
	
	Node *to = (cur->to[ch] = getNextNode());
	to->len = cur->len + 2;
	if (cur == t)
	{
		to->suff = t + 1;
	} else if (cur == t + 1)
	{
		to->suff = (t + 0)->to[ch];
	} else
	{
		cur = cur->suff;
		assert(cur != nullptr);
		while (s[pos - cur->len - 1] != s[pos])
			cur = cur->suff;
		to->suff = cur->to[ch];
	}
	assert(to->suff != nullptr);
	last = to;
//	calc(last);
}

void init()
{
	sz = 0;
	odd = getNextNode();
	even = getNextNode();
	
	odd->len = -1;
	even->len = 0;
	
	odd->cnt = 0;
	even->cnt = 0;
	
	odd->suff = nullptr;
	even->suff = odd;
	last = even;
	
//	calc(odd);
//	calc(even);
}

const int maxn = 500000;

int n;
int dp[maxn][2];
int res[maxn][2];
int z[maxn][2];
Node *was[maxn];

Node* jump(Node *cur, int len)
{
	for (int i = A - 1; i >= 0; --i)
		if (cur->p[i]->len >= len)
		{
			cur = cur->p[i];
			if (cur->len == len)
				break;
		}
	return cur;
	while (cur->len != len) // !!!!
		cur = cur->suff;
	return cur;
}

void solve()
{
	string s;
	getline(cin, s);
	s = "!" + s;
	
	init();
	const int INF = 1000000000;
	z[0][0] = 0;
	z[0][1] = INF;
	res[0][0] = 0;
	res[0][1] = INF;
	
	dp[0][0] = 0;
	dp[0][1] = INF;
	for (size_t i = 1; i < s.length(); ++i)
	{
		append(i, s);
		n++;

		
		z[n][0] = z[n][1] = INF;
		res[n][0] = res[n][1] = INF;
		was[n] = last;
		
//		dp[n][0] = INF;
//		dp[n][1] = INF;
//		for (Node *cur = last; cur->len > 0; cur = cur->suff)
//		{
//			dp[n][0] = min(dp[n][0], dp[n - cur->len][1] + 1);
//			dp[n][1] = min(dp[n][1], dp[n - cur->len][0] + 1);
//		}

		for (Node *cur = last; cur->len > 0;)
		{
//			cerr << "STEP = " << cur->len << endl;
			int p = cur->len - cur->suff->len;
//			cerr << "PERIOD = " << p << endl;
			int d = min(p + (cur->len % p), cur->len - p);
			if (3 * p > cur->len)
			{
//				cerr << "first" << endl;
				z[n - cur->len][0] = res[n - cur->len][0];
				z[n - cur->len][1] = res[n - cur->len][1];
			}
			else
			{
//				cerr << "second" << endl;
				z[n - cur->len][0] = min(z[n - cur->len][0], z[n - d - p][0]); 
				z[n - cur->len][1] = min(z[n - cur->len][1], z[n - d - p][1]);
			}
			res[n][0] = min(res[n][0], z[n - cur->len][1] + 1);
			res[n][1] = min(res[n][1], z[n - cur->len][0] + 1);
//			cerr << "NEXT = " << d << endl;
			//cur = jump(cur, d);
			if (3 * p > cur->len)
			{
				cur = cur->suff;
			}
			else
			{
				cur = was[n - p];
			}
		}
//		cerr << endl;
//		assert(res[n][0] == dp[n][0]);
//		assert(res[n][1] == dp[n][1]);
		cout << (res[n][1] == INF ? -1 : res[n][1]); 
		cout << " " << (res[n][0] == INF ? -2 : res[n][0]) << endl;
	}
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	ios_base::sync_with_stdio(false);
	solve();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
