#pragma comment(linker , "/STACK:128000000")

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li
#define link ololo

int timerR = 0;

string s;
int len[2][201000];
int go[2][26][201000];
int link[2][201000];
int cou[2][201000];
int N[2];

void init(int id, int v) {
	len[id][v] = -1;
	link[id][v] = -1;
	cou[id][v] = 0;
	for (int i = 0; i < 26; ++i) {
		go[id][i][v] = -1;
	}

}

int curv = 1;

void init(int id) {
	init(id, 0);
	init(id, 1);
	
	len[id][1] = 0;
	link[id][1] = 0;

	N[id] = 2;

	for (int i = 0; i < 26; ++i) {
		//for (int j = 0; j < 2; ++j) {
			init(id, N[id]);
			len[id][N[id]] = len[id][0] + 2;
			go[id][i][0] = N[id];

			/*if (j == 0) {
				link[id][N[id]] = 1;
			}
			else {*/
				link[id][N[id]] = 1;
			//}

			++N[id];
		//}
	}
}

void add(int id, int pos) {

	while (pos - len[id][curv] - 1 < 0 || s[pos] != s[pos - len[id][curv] - 1]) {
		curv = link[id][curv];
	}

	int newv;

	if (go[id][s[pos] - 'a'][curv] == -1) {
		init(id, N[id]);
		go[id][s[pos] - 'a'][curv] = N[id];
		len[id][N[id]] = len[id][curv] + 2;

		newv = N[id];
		++N[id];
	}
	else {
		newv = go[id][s[pos] - 'a'][curv];
	}

	if (link[id][newv] == -1) {
		curv = link[id][curv];

		while (pos - len[id][curv] - 1 < 0 || s[pos] != s[pos - len[id][curv] - 1]) {
			curv = link[id][curv];
		}

		link[id][newv] = go[id][s[pos] - 'a'][curv];
	}

	curv = newv;
	++cou[id][curv];
}

void build(int id) {
	init(id);

	curv = 1;
	for (int i = 0; i < s.size(); ++i) {
		add(id, i);
	}

	for (int i = N[id] - 1; i >= 0; --i) {
		if (link[id][i] != -1) {
			cou[id][link[id][i]] += cou[id][i];
		}
	}
}


int ans[3];

void dfs(int v0, int v1) {
	

	if ((v0 == -1 || cou[0][v0] == 0) && (v1 == -1 || cou[1][v1] == 0))
		return;
	if (v0 >= 2 || v1 >= 2) {
		if (v0 == -1 && v1 == -1) {
			return;
		}

		if(v0 == -1)
			ans[2] ++;
		if(v1 == -1)
			ans[0]++;/*
		for (int i = 0; i < 2; ++i) {
			if (v[i] == -1) {
				if (i == 0)
					ans[2]++;
				else 
					ans[0]++;
			}
		}*/

		if (v0 != -1 && v1 != -1) {
			int tmp = 0;
			if (cou[1][v1] > cou[0][v0]) {
				tmp = 2;
			}
			if (cou[1][v1] == cou[0][v0]) {
				tmp = 1;
			}
			ans[tmp]++;
		}
	}

	for (int i = 0; i < 26; ++i) {
		int to0 = (v0 == -1)?(-1):(go[0][i][v0]);
		int to1 = (v1 == -1)?(-1):(go[1][i][v1]);
		dfs(to0, to1);
	}
}

void solve() {
	++timerR;
	cout << "Case #" << timerR << ": ";
	
	for (int i = 0; i < 3; ++i) {
		ans[i] = 0;
	}
	string ss[2];
	cin >> ss[0] >> ss[1];

	for (int i = 0; i < 2; ++i) {
		s = ss[i];
		build(i);
	}

	vector <int> start(2);
	start[0] = start[1] = 1;

	dfs(start[0], start[1]);

	start[0] = start[1] = 0;
	dfs(start[0], start[1]);

	for (int i = 0; i < 3; ++i) {
		cout << ans[i] << " ";
	}
	cout << "\n";
}