#pragma comment(linker , "/STACK:128000000")

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li
#define link ololo

int timerR = 0;

string s;
int len[201000];
int go[26][201000];
int link[201000];
int cou[2][201000];
int N;

void init(int v) {
	len[v] = -1;
	link[v] = -1;
	cou[0][v] = cou[1][v] = 0;
	for (int i = 0; i < 26; ++i) {
		go[i][v] = -1;
	}

}

int curv = 1;

void init() {
	init(0);
	init(1);
	
	len[1] = 0;
	link[1] = 0;

	N = 2;

	for (int i = 0; i < 26; ++i) {
		//for (int j = 0; j < 2; ++j) {
			init(N);
			len[N] = len[0] + 2;
			go[i][0] = N;

			/*if (j == 0) {
				link[id][N[id]] = 1;
			}
			else {*/
				link[N] = 1;
			//}

			++N;
		//}
	}
}

void add(int id, int pos) {

	while (pos - len[curv] - 1 < 0 || s[pos] != s[pos - len[curv] - 1]) {
		curv = link[curv];
	}

	int newv;

	if (go[s[pos] - 'a'][curv] == -1) {
		init(N);
		go[s[pos] - 'a'][curv] = N;
		len[N] = len[curv] + 2;

		newv = N;
		++N;
	}
	else {
		newv = go[s[pos] - 'a'][curv];
	}

	if (link[newv] == -1) {
		curv = link[curv];

		while (pos - len[curv] - 1 < 0 || s[pos] != s[pos - len[curv] - 1]) {
			curv = link[curv];
		}

		link[newv] = go[s[pos] - 'a'][curv];
	}

	curv = newv;
	++cou[id][curv];
}

void build(int id) {

	curv = 1;
	for (int i = 0; i < s.size(); ++i) {
		add(id, i);
	}
	
	for (int i = N - 1; i >= 0; --i) {
		if (link[i] != -1) {
			cou[id][link[i]] += cou[id][i];
		}
	}
}


int ans[3];

void dfs(int v) {
	
	if (v == -1) {
		return;
	}

	if (cou[0][v] == 0 && cou[1][v] == 0)
		return;

	if (v >= 2) {
		
		
			int tmp = 0;
			if (cou[1][v] > cou[0][v]) {
				tmp = 2;
			}
			if (cou[1][v] == cou[0][v]) {
				tmp = 1;
			}
			ans[tmp]++;
		
	}

	for (int i = 0; i < 26; ++i) {
		dfs(go[i][v]);
	}
}

void solve() {
	++timerR;
	cout << "Case #" << timerR << ": ";
	
	for (int i = 0; i < 3; ++i) {
		ans[i] = 0;
	}
	string ss[2];
	cin >> ss[0] >> ss[1];


	init();
	for (int i = 0; i < 2; ++i) {
		s = ss[i];
		build(i);
	}

	/*vector <int> start(2);
	start[0] = start[1] = 1;

	dfs(start[0], start[1]);

	start[0] = start[1] = 0;
	dfs(start[0], start[1]);
	*/
	dfs(0);
	dfs(1);
	for (int i = 0; i < 3; ++i) {
		cout << ans[i] << " ";
	}
	cout << "\n";
}