#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

const int N = 200100;

struct Input {
	char a[2][N];
	
	bool read () {
		gets(a[0]);
		gets(a[1]);
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	
	int ans1, ans2, ans3;
	
	void write () {
		printf ("%d %d %d\n", ans1, ans2, ans3);
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

const int ALPHA = 26;

struct tree {
	tree(){}
    struct item {
    	int next[ALPHA];
    	int link;
    	int len;
    	int cnt;
    	int msk;
    	bool u;
    	item() {
    		memset(next, -1, sizeof(next));
    		link = 1;
    		len = -1;
    		cnt = 0;
    		msk = 0;
    		u = 0;
    	}
    };

    item a[N + 2];
    int lst, sz;
    int s[N];

    bool add (int tekc, int n) {
    	int cur = lst;
    	while (n - a[cur].len - 1 < 0 || s[n] != s[n - a[cur].len - 1]) {
    		cur = a[cur].link;
    	}
    	if (a[cur].next[tekc] != -1) {
    		lst = a[cur].next[tekc];
			a[a[cur].next[tekc]].cnt++;
    		return 0;
    	}
    	lst = sz;
    	a[cur].next[tekc] = sz;
    	a[cur].msk |= 1 << tekc;
    	a[sz].len = a[cur].len + 2; 
    	a[sz].cnt = 1;
    	cur = a[cur].link;
    	
    	while (n - a[cur].len - 1 < 0 || s[n] != s[n - a[cur].len - 1]) {
    		cur = a[cur].link;
    	}
    	
    	if (a[sz].len > 1) {
    		a[sz].link = a[cur].next[tekc];
    	}
    	sz++;
    	return 1;
    }
    
    void init(int n, const char *b) {
    	forn(i, n + 2) {
    		a[i] = item();
    	}
    	forn(i, n) {
    		s[i] = b[i] - 'a';
    	}
    	a[0].link = a[1].link = 0;
    	a[1].len = 0;
    	sz = 2;
    	lst = 0;
    }
};

struct Solution: Data {
	tree t[2];
	vector <int> g[N];
	
	int dfs (int v, tree& t) {
		int cnt = t.a[v].cnt;
		forn(i, g[v].size()) {
			int to = g[v][i];
			cnt += dfs(to, t);
		}
		return t.a[v].cnt = cnt;
	}
	
	void calc (int u, int v) {
		if (v != 0 && v != 1) {
			if (t[0].a[u].cnt < t[1].a[v].cnt) {
				ans3++;
			} else if (t[1].a[v].cnt < t[0].a[u].cnt) {
				ans1++;
			} else {
				ans2++;
			}
		}
		t[0].a[u].u = t[1].a[v].u = 1;
		int val = t[0].a[u].msk & t[1].a[v].msk;
		while (val) {
			int i = __builtin_ctz(val);
			calc(t[0].a[u].next[i], t[1].a[v].next[i]);
			val -= (1 << i);
		}
	}
	
	void calc2 (int v, tree& t, int& ans) {
		if (v != 0 && v != 1) {
			if (!t.a[v].u)
				ans++;
		}
		int val = t.a[v].msk;
		while (val) {
			int i = __builtin_ctz(val);
			calc2(t.a[v].next[i], t, ans);
			val -= (1 << i);
		}
	}
	
	void solve () {
		ans1 = ans2 = ans3 = 0;
		forn(i, 2) {
			int n = strlen(a[i]);
			t[i].init(n, a[i]);	
			forn(j, n) {
				t[i].add(a[i][j] - 'a', j);
			}
			forn(j, n + 2) {
				if (j > 0)
					g[t[i].a[j].link].pb(j);
			}
			dfs(0, t[i]);
			forn(j, n + 2) {
				g[j] = vector<int>();
			}
		}
		forn(i, 2) {
			calc(i, i);
			calc2(i, t[0], ans1);
			calc2(i, t[1], ans3);
		}
	}
	
	void clear () {
	}
};

Solution sol;

Input in;

void gen (char *c) {
	int s = rand() % 200000 + 1;
	forn (i, s) {
		c[i] = rand() % 26 + 'a';
	}
	c[s] = 0;
}

void gen () {
	gen(in.a[0]);
	gen(in.a[1]);
}

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("d.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
#endif/*
	for (int i = 0; 1; ++i) {
		gen();
		sol.init(in);
		sol.solve();
		if (i % 100 == 0) {
			sol.write();
		}
		sol.clear();
	}
	return 0;
	*/
	int t;
	cin >> t;
	string qwe;
	getline(cin, qwe);
	forn(i, t) {
		sol.read();
		sol.solve();
		printf ("Case #%d: ", i + 1);
		sol.write();
		sol.clear();
	}

	return 0;
}
