#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int N = (int) 3e5 + 10;
const int INF = (int) 1e9 + 10;

struct state {
	int d, r, k;
	state(int d, int r, int k): d(d), r(r), k(k) {}
};

map<int, int> ans[N][2];
int res[N][2];

bool operator<(const state& a, const state& b) {
	return mp(a.d, mp(a.r, a.k)) < mp(b.d, mp(b.r, b.k));
}

vector< state > states[N];
char s[N];

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%s", s);
	int n = strlen(s);
	states[0].pb(state(1, 0, 1));
	ans[0][0][1] = INF, ans[0][1][1] = 1, res[0][1] = INF, res[0][0] = 0, res[1][1] = 1, res[1][0] = INF;
	printf("1 -2\n");
	for (int i = 1; i < n; ++i) {
		char c = s[i];
		vector< int > pos;
		pos.pb(0), pos.pb(1);
		for (int j = 0; j < sz(states[i - 1]); ++j) {
			int k = states[i - 1][j].k, d = states[i - 1][j].d, r = states[i - 1][j].r;
			for (int x = 0; x <= min(k, 2); ++x) {
				int nlen = r + (k - x) * d + 2;
				if ((i - nlen + 1 >= 0) && (c == s[i - nlen + 1])) pos.pb(nlen);
			}
		}
		sort(pos.begin(), pos.end());
		pos.resize(unique(pos.begin(), pos.end()) - pos.begin());
		int d = INF;
		for (int j = sz(pos) - 2; j >= 0; --j)
			if (pos[j + 1] - pos[j] < d) {
				d = pos[j + 1] - pos[j];
				states[i].pb(state(d, pos[j + 1] % d, pos[j + 1] / d));
			}
		reverse(states[i].begin(), states[i].end());
		for (int j = 0; j < sz(states[i]); ++j) {
			int d = states[i][j].d, k = states[i][j].k, r = states[i][j].r;
			assert(k >= 1);
			for (int t = 0; t < 2; ++t) {
				int value = min(INF, min((r == 0) ? INF : res[i + 1 - r][t ^ 1], res[i + 1 - d - r][t ^ 1]) + 1);
				if (k >= 2) value = min(value, res[i + 1 - r - (2 * d)][t ^ 1] + 1);
				if (k >= 3) {
					assert(ans[i - d][t].count(d));
					value = min(value, ans[i - d][t][d]);
				}
				ans[i][t][d] = value;
			}
		}
		for (int t = 0; t < 2; ++t) {
			res[i + 1][t] = INF;
			for (map<int, int>::iterator it = ans[i][t].begin(); it != ans[i][t].end(); ++it) 
				res[i + 1][t] = min(res[i + 1][t], it->sc);
		}
		printf("%d %d\n", (res[i + 1][1] == INF) ? -1 : res[i + 1][1], (res[i + 1][0] == INF) ? -2 : res[i + 1][0]);
	}
	return 0;
}