#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int size = 50;
const int magic = 0;

int way[size][2];
int len[size];
int suflink[size];
int ts = 0;
int cur = 0;
long long precalc[size];
long long curans[size];

void init() {
	len[0] = -1;
	len[1] = 0;
	suflink[1] = 0;
	suflink[0] = -1;
	ts = 2;
	cur = 0;
}

int str[size];

bool addsmb(int ps, int &hcur) {
	while (ps - len[cur] - 1 < 0 || str[ps] != str[ps - len[cur] - 1])
		cur = suflink[cur];

	bool flag = false;
	if (way[cur][str[ps]] == 0) {
		way[ts][0] = way[ts][1] = 0;
		flag = true;
		hcur = cur;
		way[cur][str[ps]] = ts;
		len[ts] = len[cur] + 2;
		int h = suflink[cur];
		while (h != -1 && (str[ps] != str[ps - len[h] - 1] || way[h][str[ps]] == 0))
			h = suflink[h];
		if (h == -1)
			suflink[ts] = 1;
		else
			suflink[ts] = way[h][str[ps]];
		ts++;
	} 

	cur = way[cur][str[ps]];

	return flag;
}

void remsmb(bool flag, int rc, int ps, int hcur) {
	if (flag) {
		way[cur][0] = way[cur][1] = 0;
		way[hcur][str[ps]] = 0;
		ts--;
		cur = rc;
	} else {
		cur = rc;
	}
}

void rec(int ps, int n) {
	curans[ts - 2]++;

	if (ps == n) {
		return;
	}

	
	str[ps] = 0;
	int remcur = cur;
	int hcur;
	bool flag = addsmb(ps, hcur);
	if (flag)
		rec(ps + 1, n);
	remsmb(flag, remcur, ps, hcur);
	str[ps] = 1;
	remcur = cur;	
	flag = addsmb(ps, hcur);
	if (flag)
		rec(ps + 1, n);
	remsmb(flag, remcur, ps, hcur);
}

int n;

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	
	precalc[1] = 2ll;
precalc[2] = 4ll;
precalc[3] = 8ll;
precalc[4] = 16ll;
precalc[5] = 32ll;
precalc[6] = 64ll;
precalc[7] = 128ll;
precalc[8] = 252ll;
precalc[9] = 488ll;
precalc[10] = 932ll;
precalc[11] = 1756ll;
precalc[12] = 3246ll;
precalc[13] = 5916ll;
precalc[14] = 10618ll;
precalc[15] = 18800ll;
precalc[16] = 32846ll;
precalc[17] = 56704ll;
precalc[18] = 96702ll;
precalc[19] = 163184ll;
precalc[20] = 272460ll;
precalc[21] = 450586ll;
precalc[22] = 738274ll;
precalc[23] = 1199376ll;
precalc[24] = 1932338ll;
precalc[25] = 3089518ll;
precalc[26] = 4903164ll;
precalc[27] = 7728120ll;
precalc[28] = 12099440ll;
precalc[29] = 18825066ll;
precalc[30] = 29112876ll;
precalc[31] = 44767202ll;
precalc[32] = 68461866ll;
precalc[33] = 104153666ll;
precalc[34] = 157657852ll;
precalc[35] = 237510110ll;



	cin >> n;

	if (n <= magic) {
		init();
		rec(0, n);
		for (int i = 1; i <= n; i++)
			cout << "precalc[" << i << "] = " << curans[i] << "ll;" << endl;
	} else {
		for (int i = 1; i <= n; i++)
			cout << precalc[i] << endl;
	}

	return 0;
}