#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 40;

#define link slhfdskfh_link

int to[MAXN][2];
int link[MAXN];
int len[MAXN];
int num;
ll cnt[2][MAXN];
int s[MAXN];

int arr[30] =
{
0,
2,
4,
8,
16,
32,
64,
128,
252,
488,
932,
1756,
3246,
5916,
10618,
18800,
32846,
56704,
96702,
163184,
272460,
450586,
738274,
1199376,
1932338,
3089518,
4903164,
7728120
};

void
clear(int v)
{
	link[v] = 0;
	len[v] = 0;
	for (int i = 0; i < 2; ++i) {
		to[v][i] = 0;
	}
	cnt[0][v] = cnt[1][v] = 0;
}

void
init()
{
	num = 2;
	clear(1);
	clear(2);
	link[1] = link[2] = 1;
	len[1] = -1;
	len[2] = 0;
}

void
add(int ss, int mlen)
{
	int curId = 2;
	for (int i = 0; i < mlen; ++i) {
		s[i] = ss % 2;
		ss /= 2;
		while (i - len[curId] - 1 < 0 || s[i - len[curId] - 1] != s[i]) {
			curId = link[curId];
		}
		if (to[curId][s[i]] == 0) {
			++num;
			to[curId][s[i]] = num;
			clear(num);
			len[num] = len[curId] + 2;
			int secondId = link[curId];
			while (i - len[secondId] - 1 < 0 || s[i - len[secondId] - 1] != s[i]) {
				secondId = link[secondId];
			}
			if (to[secondId][s[i]] == 0) {
				++num;
				to[secondId][s[i]] = num;
				clear(num);
				len[num] = len[secondId] + 2;
			}
			secondId = to[secondId][s[i]];
			curId = to[curId][s[i]];
			link[curId] = secondId;
			if (curId == secondId) {
				link[curId] = 2;
			}
		} else {
			curId = to[curId][s[i]];
		}
	}
}

void
process(int ln)
{
	int res = 0;
	for (int i = 0; i < (1 << ln); ++i) {
		init();
		add(i, ln);
		if (num == ln + 2) {
			++res;
		}
	}
	printf("%d\n", res);
	fflush(stdout);
	fprintf(stderr, "%d\n", res);
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	int n;
	scanf("%d", &n);
	for (int i = 1; i <= n; ++i) {
		//process(i);
		printf("%d\n", arr[i]);
	}
	return 0;
}