#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 1e6;

int n;
char buf[N], s[N];
int d[N];
int countEnd[N], countStart[N];

int main() {
#ifdef LOCAL42
#define TASK "B"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	scanf("%s", buf);
	n = strlen(buf);
	int len = 0;
	s[len++] = '#';
	for (int i = 0; i < n; i++) {
		s[len++] = buf[i];
		s[len++] = '#';
	}
	n = len;
	int l = 0, r = -1;
	for (int i = 0; i < n; i++) {
		if (i <= r) {
			d[i] = min(r - i, d[l - (i - l)]);
		}
		while (i - d[i] - 1 >= 0 && i + d[i] + 1 < n && s[i - d[i] - 1] == s[i + d[i] + 1]) {
			d[i]++;
		}
	}
	for (int i = 0; i < n; i++) {
		countEnd[i]++;
		countEnd[i + d[i] + 1]--;
		countStart[i + 1]--;
		countStart[i - d[i]]++;
	}
	for (int i = 1; i < n; i++) {
		countStart[i] += countStart[i - 1];
		countEnd[i] += countEnd[i - 1];
	}
	int64 sum = 0;
	for (int i = 0; i < n - 1; i++) {
		if (s[i] == '#') {
			sum += 1ll * (countEnd[i] - 1) * (countStart[i] - 1);
		}
	}
	cout << sum << endl;
	return 0;
}
