#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(3e5) + 100;

struct group {

	int start, sz, diff;

	group() {}

	group(int start, int sz, int diff) {
		this->start = start;
		this->sz = sz;
		this->diff = diff;
	}

};

int last;
char s[N];
int d[N][2], min_d[N][2];
vector<group> groups, ngroups;

inline void add(int start, int sz, int diff) {
	if (start - last != diff) {
		ngroups.pb(group(start, 1, start - last));
		if (sz > 1) {
			ngroups.pb(group(start + diff, sz - 1, diff));
		}
	} else {
		ngroups.pb(group(start, sz, diff));
	}
	last = start + (sz - 1) * diff;
}

int main() {
#ifdef LOCAL42
#define TASK "F"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	gets(s);
	int n = strlen(s);
	for (int i = 0; i < n; ++i) {
		ngroups.clear();
		last = -(n + 100);
		for (int j = 0; j < sz(groups); ++j) {
			if (groups[j].start > 0 && s[groups[j].start - 1] == s[i]) {
				add(groups[j].start - 1, groups[j].sz, groups[j].diff);
			}
		}
		if (i > 0 && s[i - 1] == s[i]) {
			add(i - 1, 1, i - 1 - last);
		}
		add(i, 1, i - last);
		groups.clear();
		for (int j = 0; j < sz(ngroups); ++j) {
			if (sz(groups) > 0 && groups.back().diff == ngroups[j].diff) {
				groups.back().sz += ngroups[j].sz;
			} else {
				groups.pb(ngroups[j]);
			}
		}
		d[i][0] = d[i][1] = inf;
		d[i][(i + 1) % 2] = i + 1;
		for (int j = 0; j < 2; ++j) {
			for (int z = 0; z < sz(groups); ++z) {
				int last = groups[z].start + (groups[z].sz - 1) * groups[z].diff;
				int cur = (last > 0 ? d[last - 1][1 - j] : (j == 0 ? inf : 0)) + 1;
				if (groups[z].sz > 1 && groups[z].start - groups[z].diff >= 0) {
					cur = min(cur, min_d[groups[z].start - groups[z].diff][1 - j]);
				}
				if (groups[z].start - groups[z].diff >= 0) {
					min_d[groups[z].start - groups[z].diff][1 - j] = cur;
				}
				d[i][j] = min(d[i][j], cur);
			}
		}
		int odd = (d[i][1] == inf ? -1 : d[i][1]);
		int even = (d[i][0] == inf ? -2 : d[i][0]);
		printf("%d %d\n", odd, even);
	}
	return 0;
}
