
#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

//#define MAXN 100100
#define MAXN 35
#define SIGMA 2
#define BASE 'a'
char *s = new char[MAXN];
struct state {
    int len, link, to[MAXN];
} *st = new state[MAXN];

struct palindromic_tree {
    int last, sz, n;
    palindromic_tree() : last(1), sz(2), n(0) {
        st[0].len = st[0].link = -1;
        st[1].len = st[1].link = 0;
    }
    int extend() {
        char c = s[n++];
        int p = last;
        while (n - st[p].len - 2 < 0 || c != s[n-st[p].len-2]) {
            p = st[p].link;
        }

        if (!st[p].to[c-BASE]) {
            int q = last = sz++;
            st[p].to[c-BASE] = q;
            st[q].len = st[p].len + 2;
            int res = p;
            do {
                p = st[p].link;
            } while (p != -1 && (n < st[p].len + 2 || c != s[n-st[p].len-2]));

            if (p == -1) st[q].link = 1;
            else st[q].link = st[p].to[c-BASE];

            return res;
        }

        last = st[p].to[c-BASE];
        return -1;
    }
};


int n;
int cnt;
palindromic_tree t;

void bt(int at) {
    if (at == n) {
        /*
        for (int i = 0; i < n; i++) {
            cout << s[i];
        }
        */

        //memset(st, 0, MAXN * sizeof(state));
        /*
        int now = 0;
        for (int i = 0; i < n; i++) {
            if (!t.extend()) {
                return;
            }
        }
        */

        cnt++;

        //cout << " " << now << endl;

        return;
    }

    s[at] = 'a';
    int oldlast = t.last, parent;
    if ((parent = t.extend()) != -1) {
        bt(at + 1);
        t.sz--;
        int nd = t.sz;
        st[nd].link = 0;
        st[nd].len = 0;
        st[parent].to['a'-BASE] = 0;
    }
    t.last = oldlast;
    t.n--;


    s[at] = 'b';
    oldlast = t.last;
    if ((parent = t.extend()) != -1) {
        bt(at + 1);
        t.sz--;
        int nd = t.sz;
        st[nd].link = 0;
        st[nd].len = 0;
        st[parent].to['b'-BASE] = 0;
    }
    t.last = oldlast;
    t.n--;
}

int arr[30] = {
    2,
    4,
    8,
    16,
    32,
    64,
    128,
    252,
    488,
    932,
    1756,
    3246,
    5916,
    10618,
    18800,
    32846,
    56704,
    96702,
    163184,
    272460,
    450586,
    738274,
    1199376,
    1932338,
    3089518,
    4903164,
7728120,
12099440,
18825066,
29112876
};


/*
1 2 0
2 4 0
3 8 0
4 16 0
5 32 0
6 64 0
7 128 0
8 252 4
9 488 24
10 932 92
11 1756 292
12 3246 850
13 5916 2276
14 10618 5766
15 18800 13968
16 32846 32690
17 56704 74368
18 96702 165442
19 163184 361104
20 272460 776116
21 450586 1646566
22 738274 3456030
23 1199376 7189232
24 1932338 14844878
25 3089518 30464914
26 4903164 62205700
*/

/*
   1 2 0
2 4 0
3 8 0
4 16 0
5 32 0
6 64 0
7 128 0
8 252 4
9 488 24
10 932 92
11 1756 292
12 3246 850
13 5916 2276
14 10618 5766
15 18800 13968
16 32846 32690
17 56704 74368
18 96702 165442
19 163184 361104
20 272460 776116
21 450586 1646566
22 738274 3456030
23 1199376 7189232
24 1932338 14844878
25 3089518 30464914
26 4903164 62205700
27 7728120 126489608
28 12099440 256336016
29 18825066 518045846
30 29112876 1044628948
*/

int main() {

    int n;
    scanf("%d\n", &n);
    for (int i = 1; i <= n; i++) {
        cout << arr[i-1] << endl;
    }

    /*
    for (n = 1; n <= 30; n++) {
        cnt = 0;
        bt(0);
        cout << n << " " << cnt << " " << ((1<<n) - cnt) << endl;
    }
    */

    return 0;
}
