#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

const int N = 1000 * 1000;
const int T = 2;

#define link lnk

int tsz, to[N][T], link[N], len[N], lst;
pt from[N];

int add_node() {
	forn(i, T)
		to[tsz][i] = -1;
	return tsz++;
}

void del_node() {
	tsz--;
	to[from[tsz].ft][from[tsz].sc] = -1;
}

void init() {
	tsz = 0;
	add_node();
	add_node();

	len[0] = -1;
	len[1] = 0;

	link[0] = -1;
	link[1] = 0;

	lst = 1;
}

void add_char(char* s, int pos) {
	int v = lst;

	while (s[pos - len[v] - 1] != s[pos])
		v = link[v];

	int& nv = to[v][ s[pos] - 'a' ];

	if (nv == -1) {
		nv = add_node();
		from[nv] = mp(v, s[pos] - 'a');
		len[nv] = len[v] + 2;

		v = link[v];
		while (v != -1 && s[pos - len[v] - 1] != s[pos])
			v = link[v];

		if (v == -1)
			link[nv] = 1;
		else
			link[nv] = to[v][ s[pos] - 'a' ];
	}

	lst = nv;
}

int res = 0;
char s[40];
int ans[40];
int n;

void rec(int pos) {
	if (pos == n)
		return;
	forn(i, 2) {
		int prv = lst;
		s[pos] = 'a' + i;
		add_char(s, pos);

		if (lst != tsz - 1) {
			lst = prv;
			continue;
		}

		ans[pos]++;
		rec(pos + 1);
		del_node();
		lst = prv;
	}
}

bool read() {
	if (scanf("%d", &n) != 1)
		return false;
	return true;
}

void solve() {
	//init();

	//rec(0);

	int ans[35] = {352,4,8,16,32,64,128,252,488,932,1756,3246,5916,10618,18800,32846,56704,96702,163184,272460,450586,738274,1199376,1932338,3089518,4903164,7728120,12099440,18825066,29112876,44767202,68461866,104153666,157657852,237510110};

	forn(i, n)
		printf("%d\n", ans[i]);

}

int main() {
//#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
/*#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif*/

	read();
	solve();

	return 0;
}