#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>

using namespace std;
int ns, best[600100], st[600100], dr[600100];
long long solf;
char s[600100];

inline void Manacher()
{
    int i, j, st, dr;
    best[1] = 1;
    best[2] = 2;
    st = 1;
    dr = 3;
    for(i = 3; i <= ns; ++i)
    {
        if(i > dr)
        {
            st = dr = i;
            best[i] = 0;
            while(st > 0 && dr <= ns && s[st] == s[dr])
            {
                best[i]++;
                st--;
                dr++;
            }
            st++;
            dr--;
            continue;
        }
        j = st + (dr - i);
        if(i + best[j] - 1 < dr)
        {
            best[i] = best[j];
            continue;
        }
        best[i] = dr + 1 - i;
        st = i - best[i] + 1;
        dr = i + best[i] - 1;
        best[i]--;
        while(st > 0 && dr <= ns && s[st] == s[dr])
        {
            best[i]++;
            st--;
            dr++;
        }
        st++;
        dr--;
    }
}

int main ()
{
#ifdef local
    freopen ("b.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i;
    cin >> (s + 1);
    ns = strlen(s + 1);
    s[2 * ns + 1] = '*';
    for(i = 2 * ns; i > 0; i -= 2)
    {
        s[i] = s[i / 2];
        s[i - 1] = '*';
    }
    ns = 2 * ns + 1;
    Manacher();

    for (i = 1; i <= ns; i ++)
    {
        st[i - best[i] + 1] ++;
        st[i + 1] --;
        dr[i + best[i] - 1] ++;
        dr[i - 1] --;
    }
    for (i = 1; i <= ns; i ++)
        st[i] += st[i - 1];
    for (i = ns; i >= 1; i --)
        dr[i] += dr[i + 1];
    for (i = 2; i + 2 <= ns; i += 2)
    {
        solf += (long long)dr[i] * st[i + 2];
    }
    cout << solf << '\n';
    return 0;
}
