#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
#define pii pair <int ,int>
using namespace std;

struct Nod
{
    int len, sufflink, next[2];
};
int n, nrnod, suff, solf[65];
Nod tree[100];
char s[110];
vector <pii> G[100];

inline void Insert(int pos)
{
    int now = suff, nowlen, lit = s[pos] - '0';
    while(1)
    {
        nowlen = tree[now].len;
        if(pos - 1 - nowlen > 0 && s[pos - 1 - nowlen] == s[pos])
            break;
        now = tree[now].sufflink;
    }
    if(tree[now].next[lit] > 0)
    {
        suff = tree[now].next[lit];
        return;
    }
    nrnod++;
    suff = nrnod;
    tree[nrnod].len = tree[now].len + 2;
    tree[now].next[lit] = nrnod;
    G[nrnod].push_back(make_pair(now, lit));
    if(tree[nrnod].len == 1)
    {
        tree[nrnod].sufflink = 2;
        return;
    }
    while(1)
    {
        now = tree[now].sufflink;
        nowlen = tree[now].len;
        if(pos - 1 - nowlen > 0 && s[pos - 1 - nowlen] == s[pos])
        {
            tree[nrnod].sufflink = tree[now].next[lit];
            break;
        }
    }
}

inline void Back(int pas)
{
    if(pas == n + 1)
        return;
    int old = suff;
    s[pas] = '0';
    Insert(pas);
    if(nrnod == pas + 2)
    {
        solf[pas]++;
        Back(pas + 1);
        tree[nrnod].sufflink = 0;
        for(auto it : G[nrnod])
            tree[it.first].next[it.second] = 0;
        G[nrnod].clear();
        nrnod--;
    }
    suff = old;
    s[pas] = '1';
    Insert(pas);
    if(nrnod == pas + 2)
    {
        solf[pas]++;
        Back(pas + 1);
        tree[nrnod].sufflink = 0;
        for(auto it : G[nrnod])
            tree[it.first].next[it.second] = 0;
        G[nrnod].clear();
        nrnod--;
    }
    suff = old;
}

int main ()
{
#ifdef local
    freopen ("c.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    cin >> n;
    nrnod = 2;
    suff = 2;
    tree[1].len = -1;
    tree[1].sufflink = 1;
    tree[2].len = 0;
    tree[2].sufflink = 1;
    Back(1);
    for(int i = 1; i <= n ; ++i)
        cout << solf[i] << "\n";
    return 0;
}
