#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
using namespace std;
int T, na, nb;
char A[200100], B[200100];
struct Nod
{
    int len, sufflink, next[26], fr;
};
int nrnodA, nrnodB, suff;
Nod treeA[400100], treeB[200100];
bool lazyA[400100], lazyB[400100];
long long sol[3];

inline void Insert(Nod tree[], char s[], int pos, int ns, int &nrnod, bool lazy[])
{
    int now = suff, nowlen, lit = s[pos] - 'a';
    while(1)
    {
        nowlen = tree[now].len;
        if(pos - 1 - nowlen > 0 && s[pos - 1 - nowlen] == s[pos])
            break;
        now = tree[now].sufflink;
    }
    if(tree[now].next[lit])
    {
        suff = tree[now].next[lit];
        tree[suff].fr++;
        return;
    }
    nrnod++;
    suff = nrnod;
    tree[nrnod].len = tree[now].len + 2;
    tree[now].next[lit] = nrnod;
    if(tree[nrnod].len == 1)
    {
        tree[nrnod].sufflink = 2;
        tree[nrnod].fr = 1;
        return;
    }
    while(1)
    {
        now = tree[now].sufflink;
        nowlen = tree[now].len;
        if(pos - 1 - nowlen > 0 && s[pos - 1 - nowlen] == s[pos])
        {
            tree[nrnod].sufflink = tree[now].next[lit];
            break;
        }
    }
    tree[nrnod].fr = 1;
    lazy[nrnod] = true;
}

inline void DFS(Nod tree[], int ind, int indsol)
{
    if(ind == 0)
        return;
    if(tree[ind].fr > 0)
        sol[indsol]++;
    for(int i = 0; i < 26; ++i)
        DFS(tree, tree[ind].next[i], indsol);
}

inline void Solve(int ind1, int ind2)
{
    if(ind1 == 0 || ind2 == 0)
    {
        DFS(treeA, ind1, 0);
        DFS(treeB, ind2, 2);
        return;
    }
    if(ind1 > 2 && ind2 > 2)
    {
        if(treeA[ind1].fr > treeB[ind2].fr)
            sol[0]++;
        if(treeA[ind1].fr < treeB[ind2].fr)
            sol[2]++;
        if(treeA[ind1].fr == treeB[ind2].fr && treeA[ind1].fr > 0)
            sol[1]++;
    }
    int i;
    for(i = 0; i < 26; ++i)
        Solve(treeA[ind1].next[i], treeB[ind2].next[i]);
}

int main ()
{
#ifdef local
    freopen ("d.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, t, st, dr;
    cin >> T;

    for(t = 1; t <= T; ++t)
    {
        cin >> (A + 1);
        cin >> (B + 1);
        na = strlen(A + 1);
        nb = strlen(B + 1);
        sol[0] = sol[1] = sol[2] = 0LL;
        nrnodA = 2;
        treeA[1].len = -1;
        treeA[1].sufflink = 1;
        treeA[2].len = 0;
        treeA[2].sufflink = 1;
        suff = 2;
        for(i = 1; i <= na; ++i)
            Insert(treeA, A, i, na, nrnodA, lazyA);
        nrnodB = 2;
        treeB[1].len = -1;
        treeB[1].sufflink = 1;
        treeB[2].len = 0;
        treeB[2].sufflink = 1;
        suff = 2;
        for(i = 1; i <= nb; ++i)
            Insert(treeB, B, i, nb, nrnodB, lazyB);
        for(i = nrnodA; i > 0; --i)
        {
            if(lazyA[i])
            {
                treeA[treeA[i].sufflink].fr += treeA[i].fr;
                lazyA[i] = false;
                lazyA[treeA[i].sufflink] = true;
            }
        }
        for(i = nrnodB; i > 0; --i)
        {
            if(lazyB[i])
            {
                treeB[treeB[i].sufflink].fr += treeB[i].fr;
                lazyB[i] = false;
                lazyB[treeB[i].sufflink] = true;
            }
        }
        Solve(1, 1);
        Solve(2, 2);
        for(i = 1; i <= nrnodA; ++i)
        {
            treeA[i].fr = treeA[i].sufflink = treeA[i].len = 0;
            memset(treeA[i].next, 0, sizeof(treeA[i].next));
        }
        for(i = 1; i <= nrnodB; ++i)
        {
            treeB[i].fr = treeB[i].sufflink = treeB[i].len = 0;
            memset(treeB[i].next, 0, sizeof(treeB[i].next));
        }
        cout << "Case #" << t << ": " << sol[0] << ' ' << sol[1] << ' ' << sol[2] << "\n";
    }
    return 0;
}
