#include <stdio.h>
#include <iostream>
#include <string.h>
#include <vector>

using namespace std;

const int N = 400000;

struct Node {
	int next[28];
	int suff, sz;
	int num[2];
	Node () {
		memset(next, -1, sizeof(next));
		num[0] = num[1] = 0;
	}
};

vector<Node> tr;
bool flag;
int last, n, cnt, tt, a0, a1, a2;
string s;
char buff[N];

void init(int n) {
	tr.clear();
	tr.resize(n + 5);
	cnt = 2;
	last = 1;
	tr[0].sz = -1; tr[0].suff = 0;
	tr[1].sz = 0; tr[1].suff = 0;
}

bool add(int i) {
//	cerr << last << ": " << tr[last].sz << " " << tr[last].suff << endl;
	int cur = last;
	while ((i - tr[cur].sz - 1 < 0) || (s[i - tr[cur].sz - 1] != s[i])) {
		cur = tr[cur].suff;
	}
	int let = s[i] - 'a';
	if (tr[cur].next[let] != -1) {
		last = tr[cur].next[let];
		return false;
	}
	int x = cnt++;
	last = x;
	tr[x].sz = tr[cur].sz + 2;
	tr[cur].next[let] = x;
	if (tr[x].sz == 1) {
		tr[x].suff = 1;
		return true;
	}
	cur = tr[cur].suff;
	while ((i - tr[cur].sz - 1 < 0) || (s[i - tr[cur].sz - 1] != s[i])) {
		cur = tr[cur].suff;
	}
	cur = tr[cur].next[let];
	tr[x].suff = cur;
	return true;
}

void dfs(int x) {
	for (int i = 0; i < 26; i++) {
		int y = tr[x].next[i];
		if (y < 0) continue;
		dfs(y);
	}
	if (x >= 2) {
		if (tr[x].num[0] > tr[x].num[1]) a0++; else
		if (tr[x].num[0] < tr[x].num[1]) a2++; else
		a1++;                 
	}

}

int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d\n", &tt);
	int cur_t = 0;
	while (tt--) {
		cur_t++;
		printf("Case #%d: ", cur_t);
		gets(buff);
		buff[strlen(buff)] = 0;
		string a(buff);
		gets(buff);
		buff[strlen(buff)] = 0;
		string b(buff);
		s = a + string(1, 'a' + 26) + b + string(1, 'a' + 27);
		init(s.size());
		bool flag = false;
		for (int i = 0; i < s.size(); i++) {
			add(i);
			if (s[i] == 'a' + 26) {
				flag = true;
			} else tr[last].num[flag]++;
		}
		for (int i = cnt - 1; i >= 1; i--) {
		        for (int j = 0; j < 2; j++) {
				tr[tr[i].suff].num[j] += tr[i].num[j];
			}
		}
		a0 = a1 = a2 = 0;
		dfs(0);
		dfs(1);
		printf("%d %d %d\n", a0, a1, a2);
	}
	puts("");
}